*CMZ :  2.01/02 26/01/96  18.37.36  by  Hartwig Albrecht
*CMZ :  2.01/01 24/10/95  13.53.51  by  Hartwig Albrecht
*-- Author :    Hartwig Albrecht   24/10/95

      SUBROUTINE ALRINI

************************************************************************
*
* Description: 'pseudo-random' seed for random numbers. ALRINI provides
*              10**14 different seeds. This should be sufficient
*              to give a different seed every time.
*
* Called from: ALEVT, KASEED
*
* External references: RANECQ
*
* Argument in/out description: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"

      INTEGER SLATE, NCALL
      SAVE NCALL
      COMMON /SLATE/ SLATE(6)
      REAL T
      DATA NCALL /0/

#include "arte/Arte.ff"

C The basis for the seed are date and time:

 10   CALL DATIME (LUNDSEED(1), LUNDSEED(2))

C add seconds

      LUNDSEED(1) = 60 * LUNDSEED(1) + SLATE(6)

C add process identifier

      IF (PROCESSID .EQ. 0)  CALL MEERRC (8634753,
     +  'ALRINI: PROCESS_ID = 0: random seed may not be unique')

      LUNDSEED(2) = LUNDSEED(2) * 2400 + PROCESSID + 1

C add host identifier

      LUNDSEED(1) = LUNDSEED(1) + 60000000*INSTNUM

C add number of calls

      NCALL = NCALL + 1
      LUNDSEED(1) = LUNDSEED(1) + 60000000 * NCALL

C add exhausted time

      CALL TIMEX (T)
      T = MOD (T * 100000000., FLOAT(ILARGEST))
      LUNDSEED(2) = LUNDSEED(2) + INT(T)

      IF (LUNDSEED(1) .EQ. 0 .OR. LUNDSEED(2) .EQ. 0)  GO TO 10
      LUNDSEED(1) = ABS (LUNDSEED(1))
      LUNDSEED(2) = ABS (LUNDSEED(2))

      C78 = 'SEEDLUND'
      CALL CH78BI (LUNDSEED(1))
      CALL CH78BI (LUNDSEED(2))
      CALL CH78BC ('* automatically generated')
      CALL ME78WC (5346234)

      CALL RANECQ (LUNDSEED(1), LUNDSEED(2), 1, 'S')

      END

************************************************************************
* End of ALRINI
************************************************************************
