/***********************************************************************
* Author :    Hartwig Albrecht   16/11/95
* changed by  Siegmund Nowak     25/01/00
* Description: read necessary constants 
               either from the DB server /ARTE_GEO  if HBDATAROOT is set
*              or from  arte.cons5                  if HBDATAROOT is unset 
*
* Called from: ATINIT
*
* External references: MMREAD
*
* Arguments: none
*
* changes:
* 16 May 2000 (AG) debugged ptr declaration
*
***********************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "arte/ArteFlag.h"
#include "arte/ArteUtil.h"
#include "arte/ArteIOlun.h"
#include "arte/ArteMessage.hh"
#include "dbarte/DbArteBridge.h"
#   define DB_MAX_NAME_SIZE		80

extern "C" {
  void atcons_();
  void ioconc_(int &, char*, char*, int&, int, int);
  void iounit_(char *, int &, int);
  void mmread_(int &, char*, int);
  void chhtot_(char *, char *, int *);
}  
static int first_atcons=1; 

void atcons_() {
  if(!first_atcons) return;
  first_atcons =0;   
  int i0 =0, i4=4;
  int lun, var, ierr;
  char cname[5], ctext[78], Name[128], Opt[16] ;

  struct {char* name; int type; int Major; int Minor; } banks[]=
                 {{"TOPP",1,1,0},
                  {"MFHD",1,3,0},
                  {0,0,1,0}};

  strcpy(ctext, "read constants: ");

  char * ptr = getenv("HBDATAROOT");

  if( ptr ) {
     iounit_( "GEODB", lun, 5 );
     ArtePointer<MEIO> me(lun);   

     strncpy(me->name,"/ARTE_GEO ",10);
     me->flag =1;  
     strncpy(Name,me->name,120);  
     for(var=0;var<120 && Name[var] && Name[var]!=' ';var++);
     Name[var]=0;
     DbOpen( lun, Name, 0, &ierr );
     if(ierr) {
        arteMsg << "atcons: try it again with 'unset HBDATAROOT'";
        arteMsg.error();
     }

     for (int i=0; banks[i].name; i++){                      
        strcpy(Name,banks[i].name);   strcpy(Opt,"EQ");

  /*    Look for Bank name in MEMO bank. */
        int nlink=0;
        for( ArteTableIterator<MEMO>mo; mo.valid(); mo.next()) {
           if(!strncmp( Name, mo->name,4 ) ) {
              nlink = mo.index(); 
              break; 
           } 
        }
        if( nlink == 0 ) {
           arteMsg <<  "bank " << Name << " is not booked in MEMO bank";
           arteMsg.error();
        }

        if (banks[i].type==0) 
           DbReadTable( lun, (int *)((artelink_.larln1.getRef() + nlink)*4), 
                      banks[i].Major, banks[i].Minor, "EQ", &ierr );
        else 
           DbReadHeader( lun, (int *)((artelink_.larln1.getRef() + nlink)*4), 
                      banks[i].Major, banks[i].Minor, "EQ", &ierr );
     }
     DbClose( lun, &ierr );
     return;
  }

  else {
     int len = strcspn(arteflag_.hbdir," ");
     strncpy(arteutil_.c78, arteflag_.hbdir,len);
     strcpy(&arteutil_.c78[len],"/cons/arte.cons5"); 
    
     ioconc_(arteiolun_.lgeoi, arteutil_.c78,"IL",i0,strlen(arteutil_.c78),2);

     for (;;) {  
        mmread_(arteiolun_.lgeoi, cname, i4);
        for( int i =0;i<4;i++) cname[i] = toupper(cname[i]); 
        if(!strncmp(cname,"EOD",3)) break; 
        strncat(ctext,cname,4);
        strncat(ctext," ",1);
     } 
     arteMsg << ctext;
     arteMsg.warn();
     return;
  }
}


//  End of ATCONS


