
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
// A. Gellrich
//
// Filling of histograms
//
// hints:
//        components: COMP_SVD
//                    COMP_ITR
//                    COMP_HIPT
//                    COMP_OTR
//                    COMP_RICH
//                    COMP_TRD
//                    COMP_ECAL
//                    COMP_MUON
//                    COMP_FLT
//                    COMP_SLT
//                    COMP_TLT
//                    COMP_FARM
//
//         levels:    LVL_RAW
//                    LVL_HIT
//                    LVL_REC
//
//         histogram id: 1 - 65535
//
// changes:
// 22 Oct 1999 (AG) code polishing
// 27 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"
#include "event.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_MUON.h"

//
// function code
//
int
DQ_MUON_rec_evnt()
{
  int nrMUONtracks=0;
  for(ArteTableIterator<RSEG> track;track.valid();track.next())
    {
      float tx=track->txf;
      float ty=track->tyf;
      float xe=track->xe;
      float ye=track->ye;

      /* MUON track */
      if(track->cmp==8)
        {
          rhp_hfill(DQ_ID(COMP_MUON,LVL_REC,0x10),tx,ty,1);
          rhp_hfill(DQ_ID(COMP_MUON,LVL_REC,0x11),xe,ye,1);
          nrMUONtracks++;
        }
    }
 
  rhp_hf1(DQ_ID(COMP_MUON,LVL_REC,0x1),nrMUONtracks,1);


  return 0; // return error code (0 = okay)
}
