// 
// Boris Fominykh  9.02.1998
// updated 1.05.2000 by B.Fominykh - added the file input/output
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <fstream>
#include <iomanip>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

struct MuGeoStack {
  int  NvolStack;
  int  NvolMax;
  char NameVolStack[20][5]; 
};

static MuGeoStack  ListVolStack;

extern "C" {

int mustcheck_(char* , int*);

void mustini_() {
  ListVolStack.NvolStack = 0;
  ListVolStack.NvolMax   = 20;
}

void mustprint_() {
  fprintf(stdout,"MuGeoStack: number of volumes %d , max number %d\n",
    ListVolStack.NvolStack,ListVolStack.NvolMax);
  if(ListVolStack.NvolStack > 0) {
    for(int ic=0; ic < ListVolStack.NvolStack; ic++) {
      fprintf(stdout,"%d:  %s\n",ic+1,&ListVolStack.NameVolStack[ic][0]);
    }
  }
  return;
}

// write the structure contents to file
void mustout_() {
  ofstream fout("MuGeoStack.out");
  if (!fout) {
    arteMsg << "MuGeoStack - can not open file MuGeoStack.out for write";
    arteMsg << endl;
    arteMsg.warn();
    return;
  }
  fout << dec << ListVolStack.NvolStack << endl;
  fout << dec << ListVolStack.NvolMax << endl;
  if(ListVolStack.NvolStack > 0) {
    for(int ic=0; ic < ListVolStack.NvolStack; ic++) {
      fout << &ListVolStack.NameVolStack[ic][0] << endl;
    }
  }
  return;
}

// read the structure contents from file
void 
mustin_() 
{
     char     fname[256];
     ifstream  fin;
     fin.open("MuGeoStack.out",ios::in, 0644);
     if( !fin.is_open() )
     {
	  strcpy(fname,getenv("HBROOT"));
	  strcat(fname,"/GEO/GEAN/MuGeoStack.out");
	  fin.open(fname,ios::in,0644);
	  if (!fin.is_open()) 
	  {
	       arteMsg << "can not open file MuGeoStack.out for read";
	       arteMsg << endl;
	       arteMsg.warn();
	       return;
	  }
     }

     fin >> ListVolStack.NvolStack;
     fin >> ListVolStack.NvolMax;
     if(ListVolStack.NvolStack > 0) 
     {
	  for(int ic=0; ic < ListVolStack.NvolStack; ic++) 
	  {
	       fin >> &ListVolStack.NameVolStack[ic][0];
	  }
     }
     fin.close();
     return;
}

int mustadd_(char* name) {
  if(ListVolStack.NvolStack < ListVolStack.NvolMax) {
    int icheck = 0;
    int i=mustcheck_(name,&icheck);
    if(i == 1 || icheck == 0) { 
      i = ListVolStack.NvolStack;
      ListVolStack.NvolStack += 1;
      strcpy(&ListVolStack.NameVolStack[i][0],name);
    return 0;
    }
  }
  else {
    return 1;
  }
  return 1;
}

int mustcheck_(char* name, int* icheck) {
  *icheck = 0;
  if (ListVolStack.NvolStack < 1) return 0;
  for(int ii=0; ii < ListVolStack.NvolStack; ii++) {
    if(!strcmp(&ListVolStack.NameVolStack[ii][0],name)) {
      *icheck = 1;
      return 0;
    }
  }
  return 1;
}
}
