*CMZ :  3.01/00 20/08/96  10.33.35  by  Siegmund Nowak
*CMZ :  2.00/02 08/03/96  09.47.23  by  Siegmund Nowak

*-- Author :    Siegmund Nowak   03/02/94
      SUBROUTINE GDCXYZ
      IMPLICIT NONE
C.
C.    ******************************************************************
C.    *                                                                *
C.    *       Online display of the track trajectory                   *
C.    *                                                                *
C.    *    ==>Called by : <USER>                                       *
C.    *       Authors : R.Brun, P.Zanarini   *********                 *
C.    *       For HERA-B: if IKINE = 0 or 2:                           *
C.    *                   Hadrons are red                              *
C.    *                   Electrons/photons are blue                   *
C.    *                   Muons are violet                             *
C.    *                   charged particles are solid lines            *
C     *                   neutral particles are dotted lines           *
C.    ******************************************************************
C.
#include "gean/gcdraw.fi"
#include "gean/gckine.fi"
#include "gean/gcstak.fi"
#include "gean/gctrak.fi"
      REAL UU(2),VV(2),VOLD(3)
      INTEGER IFIRST,IOFF,ILINE,ICOL,KCOL,IMOD
      SAVE IFIRST,IOFF,ILINE,UU,VV
      DATA IFIRST/0/
C.
C.    ------------------------------------------------------------------
C.
      IF(IFIRST.EQ.0)THEN
         CALL UCTOH('OFF ',IOFF,4,4)
         CALL UCTOH('LINE',ILINE,4,4)
         IFIRST=1
      ENDIF

C             Set IOBJ to TRACK
C
      IOBJ=2
C
C             Is THRZ option set on (R-Z projection)
C             and the cut lateral (vertical or horizontal) ?
C
      IF (ITHRZ.NE.IOFF) THEN
         IF (ICUT.EQ.1.OR.ICUT.EQ.2) ITR3D=-ITRA
      ELSE
         ITR3D=0
      ENDIF

      ICOL = 1
      IF(ITRTYP.LE.2) THEN
         ICOL = 7
      ELSE IF(ITRTYP.EQ.5) THEN
         ICOL = 4
      ELSE IF(ITRTYP.EQ.3.OR.ITRTYP.EQ.4) THEN
         ICOL = 2
      ENDIF
      KCOL=LOOKTB(ICOL)
      IMOD = 1
      if(charge.eq.0.) imod = 3
C
      IF(NJTMAX.EQ.0)THEN
*
*            Normal sequential tracking
         IF(SLENG.LE.0.)THEN
            CALL GDFR3D(VECT,1,UU(1),VV(1))
            IF (ITRKOP.NE.ILINE) THEN
               CALL IPM(1,UU,VV)
            ENDIF
         ELSE
            CALL GDFR3D(VECT,1,UU(2),VV(2))
            IF (ITRKOP.EQ.ILINE) THEN
               CALL ISPLCI(KCOL)
               CALL ISLN(IMOD)
               CALL IPL(2,UU,VV)
            ELSE
               CALL IPM(1,UU(2),VV(2))
            ENDIF
            UU(1)=UU(2)
            VV(1)=VV(2)
         ENDIF
      ELSE
*
*            Parallel tracking
         CALL GDFR3D(VECT,1,UU(2),VV(2))
         IF (ITRKOP.NE.ILINE) THEN
            CALL IPM(1,UU(2),VV(2))
         ELSE
            CALL ISPLCI(KCOL)
            CALL ISLN(IMOD)
            VOLD(1)=VECT(1)-STEP*VECT(4)
            VOLD(2)=VECT(2)-STEP*VECT(5)
            VOLD(3)=VECT(3)-STEP*VECT(6)
            CALL GDFR3D(VOLD,1,UU(1),VV(1))
            CALL IPL(2,UU,VV)
            IF (IMOD.NE.1) CALL ISLN(1)
         ENDIF
      ENDIF
C
C             Reset ITR3D to 'standard projection'
C
      ITR3D=0
      IOBJ=0
C
      END



