// changed 05/07/99; 10/09/99 Torsten Zeuner
// last changes 10/03/00 TZ

#include  <stdio.h>

// ARTE
#include "arte/arte.hh"
#include "farm/farm.hh"

// libitr
#include "aframelib.h"
#include "ITR_silraw.h"
#include "ITR_arte.h"
#include "ITR_marvin.h"
#include "itrleda.h"
#include "ITR_EVinfo.h"

// return codes
#include  "grr.h"

// sparse event definition
#include "event.h"
#include "etb.h"



//-----------------------------------------------------------------

int ItrRunStart()
{
  
  char *routine = "ItrRunStart";

  static int ITR_first = 1;
  int rc;

  // return when called more then once

  if ( !ITR_first ) { 
    aframe_mess(routine,GRR_SINFO,"ItrRunStart already called - skipping...");
    return GRR_OK;
  }
  ITR_first = 0;
  
  aframe_mess(routine,GRR_SINFO,"ITR_arte started");  
  
  int major = 0;
  int minor = 0;

  rc = ITR_leda_startprogram( major, minor );
  if ( rc != GRR_OK ) return rc;


  // start ITR_silraw

  rc = ITR_silraw_startprogram();
  if ( rc != GRR_OK ) return rc;

  // start ITR_marvin

  rc = ITR_marvin_init();
  if ( rc != GRR_OK ) return rc;

  rc = ITR_fillgedeindex();
  if ( rc != GRR_OK ) return rc;

  rc = ITR_fillgedeindex();
  if ( rc != GRR_OK ) return rc; 
 
  return GRR_OK;

}

