*CMZ :  0.01/02 23/08/94  16.08.46  by  Dominik Ressing
*-- Author :    Dominik Ressing   23/08/94
************************************************************************
*
* L1GEOLC
* written by Dominik Ressing, 23/08/94 15.16.48
*
* This routines action:
*
* find crossing point x,y of two lines (x0,y0) + rlamb*(dx,dy).
* the distance from x01,y01 is returned in rlamb, from x02,y02 in alpha
* if there is now crossing point, the lines are parallel,
* rlamb,alpha,x,y are set to -999999.
*
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* x01,y01,dx1,dy1  in     Y - y01 = dy1/dx + X - x01   first line
* x02,y02,dx2,dy2  in     second line
* x,y              out    crossing point of the two lines (-999999. if parallel)
* rlamb            out    (x,y) = rlamb*(dx1,dy1) + (x01,y01)
* alpha            out    (x,y) = alpha*(dx2,dy2) + (x02,y02)
*
************************************************************************
c
      SUBROUTINE L1GEOLC(x01,y01,dx1,dy1,x02,y02,dx2,dy2,
     &                   x,y,rlamb,alpha)
c
      IMPLICIT NONE
c
      REAL x01,y01,dx1,dy1,x02,y02,dx2,dy2,x,y,rlamb,alpha,
     &     yydif,xxdif,prod1,prod2
c
c     solve the linear system :   x01-x02 = alpha*dx2 - rlamb*dx1
c                                 y01-y02 = alpha*dy2 - rlamb*dy1
c
      yydif = y01-y02
      xxdif = x01-x02
      prod1 = dy2*dx1
      prod2 = dx2*dy1
      IF ( prod1.eq.prod2 ) THEN
         alpha = -999999.
         rlamb = -999999.
         x     = -999999.
         y     = -999999.
      ELSE
         rlamb = ( dx2*yydif - dy2*xxdif )/( prod1 - prod2 )
         x = rlamb*dx1 + x01
         y = rlamb*dy1 + y01
         IF ( abs(dx2) .gt. 0 ) THEN
            alpha = (x - x02)/dx2
         ELSE IF ( abs(dy2) .gt. 0 ) THEN
            alpha = (y - y02)/dy2
         END IF
      END IF
c
      RETURN
c
      END
