*CMZ :          09/09/96  21.24.55  by  Fedor Ratnikov
*CMZ :  1.00/05 17/09/95  19.48.27  by   Ivan Belyaev
*CMZ :  1.00/00 07/02/95  20.09.47  by  Dominik Ressing
*-- Author :    Fedor Ratnikov   23/09/94
************************************************************************
*
* L1RUN
* written by Fedor Ratnikov, 1/08/96
*
* This routines action:
* Kernel routine to process L1SIMU
* Return when new event should be read
*
*  ierr         out         .NE.0 when last processed event failes
*
************************************************************************
      SUBROUTINE L1RUN(ierr)
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1runpa.fi"
#include "l1si/rchead.fi"
c
      INTEGER ierr
      LOGICAL ifirst,L1BXEXI
      DATA ifirst /.TRUE./
      SAVE ifirst
c
      ierr = 0       ! no errors so far
      IF(ifirst)  THEN     ! start event processing
       CALL L1INIT(ierr)
       ifirst = .FALSE.
       iRCEvent = 0
       L1RUNcuBX = 1 ! this event is the first one
       IF(ierr.NE.0)    GOTO 999   ! error exit
      ENDIF
c
      iRCEvent = iRCEvent+1
         CALL L1BXLNK(L1RUNcuBX) ! Link last event to the header
c
c         ---   translate data
c
         CALL L1TABBO           ! Book L1SIMU hits structure
         CALL L1TABRD           ! Fill L1SIMU hits structure
c
c        --- do simulation
c
         CALL l1runsi(ierr)
         IF(ierr.NE.0)    THEN    ! Fatal error condition
         ENDIF
c
c        Next event should be read: prepare pipeline
c
         L1RUNcuBX = L1RUNcuBX + 1 ! we start with a new bunch crossing
         IF(L1RUNcuBX.GT.L1MAXbxes)  L1RUNcuBX = 1 ! cycle events
         IF(L1BXEXI(L1RUNcuBX))   THEN ! Previous event still exists
            CALL L1BXDRP(L1RUNcuBX) ! Drop it
         ENDIF
         CALL L1BXRST(1)   ! reset current bank
 999     RETURN
c
      END
