*CMZ :          26/05/96  16.33.17  by  Fedor Ratnikov
*CMZ :  1.01/00 15/12/95  22.15.00  by  Fedor Ratnikov
*CMZ :  1.00/08 03/12/95  11.47.44  by  Fedor Ratnikov
*CMZ :  1.00/01 04/04/95  23.49.39  by  Fedor Ratnikov
*CMZ :  1.00/00 27/01/95  17.35.53  by  Dominik Ressing
*CMZ :  0.01/03 18/09/94  22.38.42  by  Fedor Ratnikov
*CMZ :  0.01/02 13/09/94  00.33.34  by  Fedor Ratnikov
*CMZ :  0.01/01 24/07/94  17.04.17  by  Dominik Ressing
*-- Author :    Dominik Ressing   24/07/94
************************************************************************
*
* L1TFUFA
* written by Dominik Ressing, 24/07/94 16.23.08
*
* This routines action:
* Simulates TFU in a fast way
*
* Arguments  kind         description
*          (in,update,out)
*-----------------------------------------------------------------------
* JobPo       in          pointer to job
* val         out         is message still valid ?
* itime       out         time at completion
* ierr        out         error flag
*
************************************************************************
c
      SUBROUTINE L1TFUFA(JobPo,val,itime,ierr)
c
      IMPLICIT NONE
#include "gean/gcbank.fi"
#include "l1si/l1locf.fi"
#include "l1si/l1runpa.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1jobdf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1prcdf.fi"
#include "l1si/l1detdf.fi"
c
      INTEGER JobPo,itime,ierr
      LOGICAL val
c
      INTEGER MePo,iTFU,nCon,iCon,iPo,iDet(L1DETSPElen),iROI,new,job,
     &        nMax,nMaxHits,Nfou,iPcPo,NminHit,iHiPosDim
      PARAMETER  (nMax=4)         ! maximal number of cells per layer/ROI
      PARAMETER  (NmaxHits=500)   ! maximal hit number for layer/ROI
      PARAMETER  (NminHit=-100)     ! minimal hit number
      PARAMETER  (iHiPosDim=(NmaxHits-NminHit)*nMax*L1HITlen)
      INTEGER iFir(nMax),iLas(nMax),iBX,N,i,j,iPoiRe,iPoi,kPo,
     &        iHiPos(L1HITlen,NminHit:nMaxHits,nMax),
     &        nPoFou,itr,
     &        nnOR,nnSI,k,l,nFr,nTo,nn,mn,mm,iHeight,Layer(nMax),
     &        kFlag,iX(NmaxHits),iY(NmaxHits),
     &        isX(NmaxHits),isY(NmaxHits),
     &        iPoPos(L1HITlen,NmaxHits,nMax),iRoiRe,
     &        iZshif,iNshif,iPshif,iPoiOl,
     &        iGeo,iCell,iInf,kj,iMaPat(nMaxHits),
     &        iCurSup,isplit,irow
      REAL    Geo(L1GEOINFlen),ROI(L1GEOINFlen),reg(L1GEOINFlen),
     &        Cross0(L1GEOINFlen),xLap,yLap,x,y,P,ROIup
      LOGICAL L1TRDCH
#include "l1si/l1mesdf.ff"
c
      val = .false.         ! message is invalid ( any found point will validate it )
      ierr = 0              ! no error found
      itime = L1RUNcutime   ! start time of processing
      nPoFou = 0            ! no points found
c
      MePo  = L1JOBstore(JobPo+L1JOBmess)                ! Message of this Job
      iPcPo = L1MEstor(MePo+L1MEnextPC)                  ! Processor of This Job
      L1PCstor(iPcPo+L1PCbusy) = L1RUNcutime+L1DEFtfucyc ! this cycle this TFU is busy
c
      IF ( L1MEstor(MePo+L1MElast).ge.1 ) THEN
         iPoiOl = MePo + L1MEpoint(1)  ! pointer to first message Point
      ELSE
         iPoiOl = MePo + L1MEpoint(0)  ! pointer to first message Point
      END IF
      iBX    = L1MESTOR(MePo+L1MEprbx)                       ! bunch crossing of message
      iRoiRe = L1MEroi(L1MEstor(MePo+L1MElast))              ! pointer to ROI
      iRoi   = MePo + iRoiRe                                 ! pointer to ROI
      L1MEstor(MePo+L1MElast) = L1MEstor(MePo+L1MElast) + 1  ! new point number
      iPoiRe = L1MEpoint(L1MEstor(MePo+L1MElast))            ! pointer to new Point
      iPoi   = MePo + iPoiRe                                 ! pointer to new Point
c
c Especially for muon system (MU4)
c
c      IF(L1MEstor(MePo+L1MEprid).eq.L1PREmuon) THEN
c        IF (L1MEstor(MePo+L1MElast).eq.2) THEN
c         iRoi = MePo + L1MEroi(0)
c        ELSE IF (L1MEstor(MePo+L1MElast).eq.3)
c         iRoi = MePo + L1MEroi(1)
c        ENDIF
c      ENDIF

c
      iTFU = L1PCstor(iPcPo+L1PCnum)                     ! get TFU num
      iCurSup = L1DEFtfudef(L1TFUsup,iTFU)
      IF (L1PARprnlev.ge.1 ) THEN
         WRITE (L1LUNprn,998) iTFU,iCurSup
 998     FORMAT(1x,'L1TFUFA==> BEGIN ',21('#'),' TFU',i03,
     &        ' | SL',i02,1x,21('#'))
      END IF
c
      IF(iCurSup.EQ.L1TRDSL.AND.
     &     L1MEstor(MePo+L1MEprid).EQ.L1PREelec) THEN ! Call TVU before
                                                      ! TFU processing for
                                                      ! electrons
       IF(.NOT.L1TRDCH(T1MEstor(iROI+L1ROIreg+L1GEOINFx0),
     &      T1MEstor(iROI+L1ROIreg+L1GEOINFsx),
     &      T1MEstor(iROI+L1ROIreg+L1GEOINFy0),
     &      T1MEstor(iROI+L1ROIreg+L1GEOINFsy),
     &      T1MEstor(iROI+L1ROIreg+L1GEOINFz),
     &      T1MEstor(iROI+L1ROIdxdz),
     &      T1MEstor(iROI+L1ROIdydz),
     &      MePo))  THEN        ! ROI is not consistent with e-hypothesys
        val = .false.           ! message discarded
        IF (L1PARprnlev.ge.1 ) THEN
         WRITE (L1LUNprn,*)
     &        ' L1TFUFA==> TRD reject this message'
        END IF
        GOTO 667                ! end this message processing
                                ! hypothesys
       ELSE
        IF (L1PARprnlev.ge.1 ) THEN
         WRITE (L1LUNprn,*)
     &        ' L1TFUFA==> TRD pass this message'
        END IF
       ENDIF
      ENDIF
      nCon = L1DEFtfudef(L1TFUnsec,iTFU)
      iDet(L1DETSPEdet)   = L1DEFtfudef(L1TFUdetsl,iTFU) ! detector
      DO iCon = 1,nCon                                   ! loop over all connections
         iPo = L1DETCONdetpo(iCon,iTFU)                  ! get pointer to range info
         iDet(L1DETSPElayer) = L1DEFtfudef(L1TFUlaz,iTFU) ! zero layer
         iDet(L1DETSPEsection) = L1DETCONstor(iPo+L1DETCONsec)  ! section
         CALL l1detif(iDet,iGeo,iInf,iCell)  ! obtain detector and cell geometry/info
         IF ( iGeo.le.0 ) THEN               ! Detector specifier iDet invalid !!!
            WRITE(L1LUNprn,*) 'L1MESUP ==> invlaid detector'
     $           ,iDet(L1DETSPEdet),iDet(L1DETSPElayer)
     $           ,iDet(L1DETSPEsection)
            ierr = 2                         ! for shure a fatal error
            GO TO 667
         END IF
         CALL UCOPY(Q(iGEO+1),Geo(1),L1GEOINFlen)       ! copy detector geometry
         Geo(L1GEOINFx0) = T1DETCONstor(iPo+L1DETCONx0) ! by TFU covered part
         Geo(L1GEOINFsx) = T1DETCONstor(iPo+L1DETCONxs) !
         CALL UCOPY(T1MEstor(iROI+L1ROIreg+1),
     &        ROI(1),L1GEOINFlen)                       ! copy ROI
                                                        ! geometry
         IF(iCurSup.EQ.L1DEFsupMU1) THEN ! MU1: messages might be splitted
          isplit = L1MEstor(MePo+L1HAteta)/100 ! Number of the splitted
                                               ! message
          IF(isplit.GT.0)  THEN ! splitting has been made
           IF(IQ(iInf+L1DETINFwirepad).GT.1)  THEN ! pad chamber
            irow = MOD(L1MEstor(MePo+L1HAteta),100)
            ROIup = ROI(L1GEOINFy0)+ROI(L1GEOINFsy) ! original up position
            ROI(L1GEOINFy0) = MAX(ROI(L1GEOINFy0),
     &           Q(iGeo+L1GEOINFy0)+
     &           Q(iCell+L1GEOINFsy)*(irow-0.999)) ! low border
            ROI(L1GEOINFsy) = MIN(ROIup-ROI(L1GEOINFy0),
     &           Q(iGeo+L1GEOINFy0)-ROI(L1GEOINFy0)+
     &           Q(iCell+L1GEOINFsy)*(irow+1.999)) ! low border
            IF (L1PARprnlev.ge.2 ) THEN
             WRITE (L1LUNprn,990) 
     &              isplit,ROI(L1GEOINFy0),ROI(L1GEOINFsy)
 990         FORMAT ('L1TFUFA==> splitted message formed. No/y0/sy: ',
     &            i2,f8.2,f7.2)
            END IF
           ELSEIF(isplit.GT.1)    THEN ! wire chamber: only first
            val = .false.              ! message considered
            IF (L1PARprnlev.ge.2 ) THEN
             WRITE (L1LUNprn,*)
     &            ' L1TFUFA==> child message discarded. isplit:',isplit
            END IF
            GOTO 667     ! end this message processing
           ENDIF                ! pad chamber
          ENDIF                 ! splitting take place
         ENDIF                  ! if mu1
         CALL l1detis(Geo,ROI,reg)! det. and ROI intersection
         IF ( reg(L1GEOINFsx).le.0. ) GO TO 555         ! no intersection -> next iCon
c
         IF (L1PARprnlev.ge.2) THEN
            WRITE(L1LUNprn,800) reg(L1GEOINFx0),
     &            reg(L1GEOINFsx),reg(L1GEOINFy0),
     &            reg(L1GEOINFsy),reg(L1GEOINFz )
 800        FORMAT(1x,'L1TFUFA==>   search in x,sx,y,sy,z:',
     &            5f8.2)
         END IF
c
         nnOR = L1DETCONstor(iPo+L1DETCONnORed)
         nnSI = L1DETCONstor(iPo+L1DETCONnsing)
         IF ( nnOR.gt.0 ) THEN                              ! any ``ORed cells'' ranges?
            IF (IQ(iInf+L1DETINFwirepad).gt.1) THEN            ! invalid for PAD-like
               WRITE (L1LUNprn,*)
     &              'L1TFUfa==> unimplemented PAD ORing'
               ierr = 4
               GO TO 666
            END IF
            IF ( nnSI.ne.3 .and. nnSI.ne.0 ) THEN
               WRITE (L1LUNprn,*)
     &              'L1TFUfa==> unimplemented connection ORing'
               ierr = 5
               GO TO 666
            END IF
            IF ( nnOR.ne.3 ) THEN
               WRITE (L1LUNprn,*)
     &              'L1TFUfa==>  To many OR ranges',nnOR
               ierr = 6
               GO TO 666
            END IF
         END IF
c
c        --- get cell ranges and hits in ranges for ROI:
         kPo = iPo + L1DETCONrange  ! first connection       ! pointer to first layer
         IF (IQ(iInf+L1DETINFwirepad).eq.1) THEN                ! wire like ??
            CALL VZERO(iHiPos,iHiPosDim)                     ! clear hit storage
            DO i=1,3                                         ! loop over projections
               Layer(i) = L1DETCONstor(kPo+L1DETCONlayer)    ! layer number for range
               iDet(L1DETSPElayer) = Layer(i)
               CALL l1celrg(iDet,reg,
     &              T1MEstor(iROI+L1ROIdxdz),      ! x-shift of ROI for z-shift of det.
     &              T1MEstor(iROI+L1ROIdydz),      ! y-shift of ROI for z-shift of det.
     &              1,                             ! dont care about detector bounds
     &              1,Nfou,iFir(i),iLas(i))        ! calculate 1 range in ROI
               IF (L1PARprnlev.ge.3) THEN
                  WRITE(L1LUNprn,880) Layer(i),Nfou,iFir(i),iLas(i)
 880              FORMAT(' L1TFUFA==> Layer no ',i1,
     &                 ' Nfou/iFir/iLas: ',i1,2i5)
               END IF
               IF ( Nfou.gt.1 ) THEN                         ! check consistency
                  WRITE(L1LUNprn,*)                          ! -> only one row of
     &                 'L1TFUFA==> to much ranges 1',Nfou    !    cells allowed
                  ierr = 3
                  GO TO 666
               ELSE IF (Nfou.eq.0 ) THEN                     ! no cells found !!
                  GO TO 555                                  ! -> next Connection
               END IF
               N = iLas(i) - iFir(i) + 1                     ! # of Cells in range
               IF ( N.gt.NmaxHits ) THEN
                  WRITE(L1LUNprn,*)
     &                 'L1TFUFA==> to much hits -> limited',N
                  N = NmaxHits
                  iLas(i) = iFir(i) + N - 1
               END IF
c
               CALL l1higet(iPcPo,iCon,i,                    ! search for hitted Cells
     &              iBX,iFir(i),N,iHiPos(1,1,i))
               IF (L1PARprnlev.ge.4) THEN
               nn = 0
               DO j=1,N
               IF ( iHiPos(l1hitnpo,j,i) .gt.0 ) THEN
                  nn = nn + 1
                  IF ( nn.eq.1 ) WRITE(L1LUNprn,888)
                  CALL l1hitif(iDet,iFir(i)+j-1,Cross0)
                  l = iHiPos(L1HITpos,j,i)
                  CALL l1gepot(l,l,l,itr)
                  CALL l1getrp(itr,Cross0(L1GEOINFz),x,y,P)
                  IF ( ABS(Cross0(L1GEOINFx0)).lt.100. ) THEN
                  WRITE(L1LUNprn,887) iFir(i)+j-1,
     &                 Cross0(L1GEOINFx0),Cross0(L1GEOINFsx),
     &                 Cross0(L1GEOINFy0),Cross0(L1GEOINFsy),
     &                 Cross0(L1GEOINFsin_al)/Cross0(L1GEOINFcos_al),
     &                 itr,x,y,Cross0(L1GEOINFz),
     &                 Cross0(L1GEOINFx0)+Cross0(L1GEOINFsx)*0.5+
     &                 Cross0(L1GEOINFsin_al)/Cross0(L1GEOINFcos_al)*
     &                 (y-Cross0(L1GEOINFy0))
                  ELSE
                  WRITE(L1LUNprn,889) iFir(i)+j-1,
     &                 Cross0(L1GEOINFx0),Cross0(L1GEOINFsx),
     &                 Cross0(L1GEOINFy0),Cross0(L1GEOINFsy),
     &                 Cross0(L1GEOINFsin_al)/Cross0(L1GEOINFcos_al),
     &                 itr,x,y,Cross0(L1GEOINFz),
     &                 Cross0(L1GEOINFx0)+Cross0(L1GEOINFsx)*0.5+
     &                 Cross0(L1GEOINFsin_al)/Cross0(L1GEOINFcos_al)*
     &                 (y-Cross0(L1GEOINFy0))
                  END IF
               END IF
               END DO
 888           FORMAT(1x,'L1TFUFA==> Cell',4x,'x0',4x,'sx',4x,'y0',
     &                4x,'sy',1x,'talp| TRK',5x,'x',5x,'y',6x,
     &                'z|Po   x')
 889           FORMAT(12x,I04,4f6.1,1x,f4.2,'|',i4,
     &                2f6.1,f7.1,'|',f6.1)
 887           FORMAT(12x,I04,2f6.2,2f6.1,1x,f4.2,'|',i4,
     &                f6.2,f6.1,f7.1,'|',f7.2)
               END IF
c
               IF (nnOR.gt.0) THEN                           ! OR hits ??
                  IF (nnSI.eq.0) THEN
                     l = 1                                      ! OR all hits
                  ELSE
                     l = L1DETCONstor(kPo+L1DETCONlast) + 1     ! OR from l on
                  END IF
                  k = l
                  DO j=l,N
                     IF (iHiPos(L1HITnpo,j,i).gt.0) THEN     ! Do OR-ing
                        nTo = iHiPos(L1HITnpo,k,i)
                        nFr = iHiPos(L1HITnpo,j,i)
                        nn = nTo+nFr
                        mn = L1HITpos
                        DO mm=nTo-1+L1HITpos,nn-1+L1HITpos
                           iHiPos(mm,k,i) = iHiPos(mn,j,i)
                           mn = mn + 1
                        END DO
                        iHiPos(L1HITnpo,k,i) = nn
                        IF ( MOD(j,2).eq.0 ) THEN
                           iHiPos(L1HITvalue,k,i) =           ! Set Amplitude
     &                          iHiPos(L1HITvalue,j,i)
                        ELSE
                           iHiPos(L1HITvalue,k,i) =           ! minimal value wins
     &                          MIN(iHiPos(L1HITvalue,j,i),
     &                          iHiPos(L1HITvalue,k,i))
                        END IF
                     END IF
                     k = k + MOD(j,2)             ! increment k only every second time
                  END DO
               END IF
               kPo = kPo + L1DETCONrangelen              ! next connection range pointer
            END DO
            Nfou  = 3
       ELSE                 ! PAD-like !!
            CALL VZERO(iHiPos,iHiPosDim)
            DO i=1,3
               Layer(i) = L1DETCONstor(kPo+L1DETCONlayer) ! only one
                                                          ! actual layer!!!!
            ENDDO
            iDet(L1DETSPElayer) = Layer(1)
            CALL l1celrg(iDet,reg,
     &            T1MEstor(iROI+L1ROIdxdz), ! x-shift of ROI for z-shift of det.
     &            T1MEstor(iROI+L1ROIdydz), ! y-shift of ROI for z-shift of det.
     &            1,                        ! dont care about detector bounds
     &            3,                        ! Only 3 rows allowed
     &            Nfou,iFir,iLas)      ! calculate all regions
            IF ( Nfou.gt.3 ) THEN        ! storage limit
               WRITE(L1LUNprn,*)
     &                 'L1TFUFA==> to much ranges -> limited',Nfou
               Nfou = 3
            END IF
            DO i=1,Nfou
               IF(i.GT.1.AND.iFir(i).LE.iFir(i-1))   THEN ! safety
                  WRITE(L1LUNprn,*)
     &                 'L1TFUFA==> ranges should be increasing! STOP!!!'
                  STOP 'L1TFUFA'
               ENDIF
               N = iLas(i) - iFir(i) + 1                 ! size of range
               IF ( N.gt.NmaxHits ) THEN
                  WRITE(L1LUNprn,*)
     &                 'L1TFUFA==> to much hits -> limited',N
                  N = NmaxHits
               END IF
               CALL l1higet(iPcPo,iCon,1, ! hits are assigned to layer 1
     &              iBX,iFir(i),N,iHiPos(1,1,i)) ! get Hit Pointers
c
               IF (L1PARprnlev.ge.4) THEN
                nn = 0
                DO j=1,N
                 IF ( iHiPos(l1hitnpo,j,i) .gt.0 ) THEN
                  nn = nn + 1
                  IF ( nn.eq.1 ) WRITE(L1LUNprn,888)
                  CALL l1hitif(iDet,iFir(i)+j-1,Cross0)
                  l = iHiPos(L1HITpos,j,i)
                  CALL l1gepot(l,l,l,itr)
                  CALL l1getrp(itr,Cross0(L1GEOINFz),x,y,P)
                  IF ( ABS(Cross0(L1GEOINFx0)).lt.100. ) THEN
                   WRITE(L1LUNprn,887) iFir(i)+j-1,
     &                  Cross0(L1GEOINFx0),Cross0(L1GEOINFsx),
     &                  Cross0(L1GEOINFy0),Cross0(L1GEOINFsy),
     &                  Cross0(L1GEOINFsin_al)/Cross0(L1GEOINFcos_al),
     &                  itr,x,y,Cross0(L1GEOINFz),
     &                  Cross0(L1GEOINFx0)+Cross0(L1GEOINFsx)*0.5+
     &                  Cross0(L1GEOINFsin_al)/Cross0(L1GEOINFcos_al)*
     &                  (y-Cross0(L1GEOINFy0))
                  ELSE
                   WRITE(L1LUNprn,889) iFir(i)+j-1,
     &                  Cross0(L1GEOINFx0),Cross0(L1GEOINFsx),
     &                  Cross0(L1GEOINFy0),Cross0(L1GEOINFsy),
     &                  Cross0(L1GEOINFsin_al)/Cross0(L1GEOINFcos_al),
     &                  itr,x,y,Cross0(L1GEOINFz),
     &                  Cross0(L1GEOINFx0)+Cross0(L1GEOINFsx)*0.5+
     &                  Cross0(L1GEOINFsin_al)/Cross0(L1GEOINFcos_al)*
     &                  (y-Cross0(L1GEOINFy0))
                  END IF
                 END IF
                END DO
               ENDIF
c
            END DO
            iHeight = Nfou
         END IF
c
c        --- geometry of reference cell and matrix flag
         CALL l1tfumf(iDet,Layer(L1DETCONposZ),Layer(L1DETCONposP),
     &        Layer(L1DETCONposN),iFir(L1DETCONposZ),
     &        iFir(L1DETCONposP),iFir(L1DETCONposN),
     &        reg,T1MEstor(iROI+1),Cross0,
c     &        reg,T1MEstor(iPoiOl+L1POreg+1),Cross0,
     &        xLap,yLap,
     &        kFlag,iZshif,iPshif,iNshif,iHeight)
c
         IF ( kFlag.EQ.0 ) GO TO 555
         CALL l1shlim(iZshif,NminHit,NmaxHits,L1DEFtfuMxWid,'Z') ! see on bottom
         CALL l1shlim(iPshif,NminHit,NmaxHits,L1DEFtfuMxWid,'P')
         CALL l1shlim(iNshif,NminHit,NmaxHits,L1DEFtfuMxWid,'N')
c
         IF (L1PARprnlev.ge.3) THEN
            WRITE(L1LUNprn,890) 'POS:',iPshif,
     &           iFir(L1DETCONposP),iLas(L1DETCONposP),
     &           (iHiPos(L1HITnpo,i,L1DETCONposP),i=iPshif,
     &           iLas(L1DETCONposP)-iFir(L1DETCONposP)+iPshif)
            WRITE(L1LUNprn,890) 'NEG:',iNshif,
     &           iFir(L1DETCONposN),iLas(L1DETCONposN),
     &           (iHiPos(L1HITnpo,i,L1DETCONposN),i=iNshif,
     &           iLas(L1DETCONposN)-iFir(L1DETCONposN)+iNshif)
            WRITE(L1LUNprn,890) 'ZER:',iZshif,
     &           iFir(L1DETCONposZ),iLas(L1DETCONposZ),
     &           (iHiPos(L1HITnpo,i,L1DETCONposZ),i=iZshif,
     &           iLas(L1DETCONposZ)-iFir(L1DETCONposZ)+iZshif)
 890        FORMAT(12x,a4,1x,i3,2(1x,i3),1x,
     &           '|',50(i1:)/27x,'|',50(i1:))
         END IF
c
c        --- find points in matrix
         N = NmaxHits
         CALL l1tfumx(iHiPos(1,iZshif,L1DETCONposZ),
     &                iHiPos(1,iPshif,L1DETCONposP),
     &                iHiPos(1,iNshif,L1DETCONposN),
     &                iHeight,kFlag,
     &                N,iX,iY,isX,isY,
     &                iPoPos(1,1,L1DETCONposZ),
     &                iPoPos(1,1,L1DETCONposP),
     &                iPoPos(1,1,L1DETCONposN))
c
         IF (L1PARprnlev.ge.3) THEN
            CALL VZERO(iMaPat,nMaxHits)
            DO i=1,n
               DO j=iX(i),isX(i)+iX(i)-1
                  IF ( j.lt.nMaxHits ) THEN
                     iMaPat(j) = 1
                  ELSE
                     WRITE(L1LUNprn,*)
     &                    ' L1TFUFA==> invalid matrix hit ',j
                  END IF
               END DO
            END DO
            WRITE(L1LUNprn,891)
            WRITE(L1LUNprn,892) iHeight,kFlag,Cross0(L1GEOINFsx),
     &           (iMaPat(j),j=1,50)
 891        FORMAT(12x,66('-'))
 892        FORMAT(12x,'h=',i1,' f=',i4,' d=',f4.2,'|',50i1)
         END IF
c
c Loop over all found points. First the current message is duplicated to save its
c contents for the handling of the next points (at the end of the routine it is
c deleted). Then the current message is updated and, if it is not the first point,
c a new job is created. At the end of each point the duplicated message becomes the
c current message.
c
         L1MEstor(MePo+L1MEactive) = L1MEacTFU ! last processed is TFU
         DO i=1,N
            val = .true.
            CALL l1mesdp(MePo,new)             ! duplicate non updated message
            IF ( new.le.0 ) THEN               ! success ??
               ierr = 2
               GO TO 667
            END IF
            nPoFou = nPoFou + 1                ! book-keeping over found ``points''
c
c           --- fill message structure for found point
            L1MEstor(iPoi+L1POpcpo) = iPcPo
            L1MEstor(iPoi+L1POtrkn) = iPoPos(L1HITpos,i,L1DETCONposN)
            L1MEstor(iPoi+L1POtrk0) = iPoPos(L1HITpos,i,L1DETCONposZ)
            L1MEstor(iPoi+L1POtrkp) = iPoPos(L1HITpos,i,L1DETCONposP)
            L1MEstor(iPoi+L1POsup)  = iCurSup
            kPo = iPoi + L1POreg
            T1MEstor(kPo+L1GEOINFx0) = Cross0(L1GEOINFx0) +
     &           FLOAT(iX(i)+iZshif-2)*Cross0(L1GEOINFsx)-xLap/2.
            T1MEstor(kPo+L1GEOINFsx) =
     &           Cross0(L1GEOINFsx)*FLOAT(isX(i))+xLap
c
c We have to treat y coordinate for MU3&MU4 in a different way
c

      IF(L1MEstor(MePo+L1MEprid).eq.L1PREmuon.AND.
     &           L1MEstor(iPoi+L1POsup).GE.L1DEFsupMU3)  THEN
       IF(L1MEstor(iPoi+L1POsup).EQ.L1DEFsupMU4) THEN
        T1MEstor(kPo+L1GEOINFy0) =
     &       T1MEstor(MePo+L1MEpoint(0)+L1POreg+L1GEOINFy0)
        T1MEstor(kPo+L1GEOINFsy) =
     &       T1MEstor(MePo+L1MEpoint(0)+L1POreg+L1GEOINFsy)
       ELSEIF(L1MEstor(iPoi+L1POsup).EQ.L1DEFsupMU3) THEN
        T1MEstor(kPo+L1GEOINFy0) =
     &       T1MEstor(MePo+L1MEpoint(1)+L1POreg+L1GEOINFy0)
        T1MEstor(kPo+L1GEOINFsy) =
     &       T1MEstor(MePo+L1MEpoint(1)+L1POreg+L1GEOINFsy)
       ENDIF
      ELSE
         T1MEstor(kPo+L1GEOINFy0) = Cross0(L1GEOINFy0) +
     &        FLOAT(iY(i))*Cross0(L1GEOINFsy)/2.-yLap/2.
            T1MEstor(kPo+L1GEOINFsy) =
     &           Cross0(L1GEOINFsy)*FLOAT(isY(i))/2.+yLap
      ENDIF



            T1MEstor(kPo+L1GEOINFz ) = Geo(L1GEOINFz)
            T1MEstor(kPo+L1GEOINFsin_al) = 0.
            T1MEstor(kPo+L1GEOINFcos_al) = 1.
c
            IF (L1PARprnlev.ge.2) THEN
               WRITE(L1LUNprn,900) T1MEstor(kPo+L1GEOINFx0),
     &            T1MEstor(kPo+L1GEOINFsx),T1MEstor(kPo+L1GEOINFy0),
     &            T1MEstor(kPo+L1GEOINFsy),T1MEstor(kPo+L1GEOINFz )
 900           FORMAT(1x,'L1TFUFA==> found point x,sx,y,sy,z:',
     &            5f8.2)
               CALL L1PRTPO(iPoPos(L1HITpos,i,L1DETCONposZ),
     &                      iPoPos(L1HITpos,i,L1DETCONposP),
     &                      iPoPos(L1HITpos,i,L1DETCONposN),
     &                      T1MEstor(kPo+L1GEOINFz))
            END IF
c
            IF ( nPoFou.eq.1 ) THEN                   ! first point ?
               itime = itime+L1DEFtfucyc*L1DEFtfuNcyc    ! time for a straight pass
            ELSE
               itime = itime+L1DEFtfucyc                 ! next cycle for serialization
            END IF
            L1MEstor(iPoi+L1POtime) = itime
c
            CALL l1mesup(MePo,itime,ierr)             ! update message (get ROI(s))
            IF(ierr.ne.0)    THEN                     ! RPC not found
               CALL l1mescp(new,MePo)                 ! restore original message
               CALL l1mesde(new,L1MEDEnousr)          ! Remove duplicated message
               new = MePo                             ! this is the next time used one
               nPoFou = nPoFou - 1                    ! this point was invalid
               IF ( ierr.eq.1 ) THEN
                  ierr = 0                            ! clear not-found-error
               ELSE
                  GO TO 667
               END IF
            ELSEIF(nPoFou.gt.1)   THEN                ! not first point ??
               CALL l1jobsb(MePo,itime,job)           ! submitt new job with message
               IF ( job.le.0 ) THEN
                  CALL l1mescp(new,MePo)              ! restore original message
                  CALL l1mesde(new,L1MEDEnousr)       ! Remove duplicated message
                  new = MePo                          ! this is the next time used one
                  ierr = 2
                  GO TO 667
               END IF
            ENDIF
c
c           --- re-use original message for next steps (saved in new)
            MePo = new                                ! new current message
            iPoi = MePo + iPoiRe                      ! new Point Pointer
            iROI = MePo + iRoiRe                      ! new ROI Pointer
         END DO
 555     CONTINUE   ! end of connections loop
      END DO
c
 666  CONTINUE      ! exit
      IF ( nPoFou.ge.1 ) THEN            ! current message a duplicated one ?
         CALL l1mesde(MePo,L1MEDEnousr)  ! delete it without user notification
      END IF
 667  CONTINUE      ! message dupllication error exit
c
      IF ( ierr.ne.0 .or. nPoFou.eq.0 ) val = .false. ! error or nothing found
      IF ( ierr.eq.1 ) ierr = 0                       ! clear this error (from l1mesup)
c
      IF (L1PARprnlev.ge.1 ) THEN
         WRITE (L1LUNprn,999)
 999     FORMAT(1x,'L1TFUFA==> END ',60('#'))
      END IF
c
      RETURN
c
      END
c
      SUBROUTINE l1shlim(i,imin,imax,iwid,what)
      IMPLICIT none
#include "l1si/l1param.fi"
      INTEGER i,imin,imax,iwid
      CHARACTER*1 what
c
      IF ( i.lt.imin .or. i+iwid-1.gt.imax) THEN
         WRITE(L1LUNprn,900) what,i,iwid,imin,imax
 900     FORMAT(1x,'L1TFUFA==> limit ',A1,'-shift :',4i5)
         i = MIN(MAX(i,imin),imax-iwid+1)
      END IF
      RETURN
      END
