*CMZ :          05/09/96  20.40.24  by  Fedor Ratnikov
*CMZ :  1.00/01 05/03/95  00.39.28  by  Fedor Ratnikov
*CMZ :  1.00/00 29/01/95  20.31.54  by  Fedor Ratnikov
*-- Author :    Dominik Ressing   10/01/95
************************************************************************
*
* L1USRPR
* written by Dominik Ressing, 10/01/95 12.32.13
*
* This routines action:
*
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* MePo            in      Message pointer
* th              in      Energy/momentum threshold of this pretrigger
* E0              in      Energy as measured in Pretrigger
* Exp,Exm,Eyp,Eym in      neighbour energies for ecal
*
************************************************************************
c
      SUBROUTINE L1USRPR(MePo,th,E0,Exp,Exm,Eyp,Eym)
c
      IMPLICIT NONE
c
#include "arte/Arte.fi"
#include "auto/MC.fi"
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1mesdf.fi"
#include "l1si/l1user.fi"
#include "l1si/l1banks.fi"
#include "l1si/rchead.fi"
c
      INTEGER MePo,iType,iTrk,iPoPo,iFlag
      REAL    th,E0,Exp,Exm,Eyp,Eym,xPo,yPo,zPo,P
      LOGICAL HEXIST
      INTEGER idorig2,ibxx
      REAL xorig2,yorig2,zorig2,porig2
      CHARACTER*4 cName
      COMMON /USRTMP/ idorig2,xorig2,yorig2,zorig2,porig2,ibxx
#include "arte/Arte.ff"
#include "l1si/l1mesdf.ff"
#include "auto/MC.ff"
c
c
      IF(HEXIST(L1PRETUPnr))    THEN
         iType = L1MEstor(MePo+L1HAprid)  ! pretrigger type
         ibxx = iRCEvent
         IF(iType.EQ.L1PREelec) THEN    ! electron pretrigger
            CALL L1ECAPO(MePo,iTrk,xPo,yPo,zPo)
            CALL L1GETRP(iTrk,zPo,xPo,yPo,P)
c
            ibxx = iRCEvent
            L1PRETUType  = iType
            L1PRETUTrk   = MIN(iTrk,1000)
            CALL l1cpart(OMTRA_TOPP(iTrk),L1PRETUTraID,cName)
            T1PRETUThre  = th
            iPoPo = MePo+L1MEpoint(0)+L1POreg
            T1PRETUdx    = T1MEstor(iPoPo+L1GEOINFsx)*0.5
            T1PRETUx     = T1MEstor(iPoPo+L1GEOINFx0)+T1PRETUdx
            T1PRETUdy    = T1MEstor(iPoPo+L1GEOINFsy)*0.5
            T1PRETUy     = T1MEstor(iPoPo+L1GEOINFy0)+T1PRETUdy
            T1PRETUE     = E0
            T1PRETUEXp   = Exp
            T1PRETUEXm   = Exm
            T1PRETUEYp   = Eyp
            T1PRETUEYm   = Eym
            iPoPo = MePo+L1POlcog
            T1PRETUdxCOG = T1MEstor(iPoPo+L1GEOINFx0)+
     &           0.5*T1MEstor(iPoPo+L1GEOINFsx)-T1PRETUx
            T1PRETUdyCOG = T1MEstor(iPoPo+L1GEOINFy0)+
     &           0.5*T1MEstor(iPoPo+L1GEOINFsy)-T1PRETUy
            T1PRETUETrk  = P
            T1PRETUdTRKx = MAX(-40.,MIN(40.,xPo-T1PRETUx))
            T1PRETUdTRKy = MAX(-40.,MIN(40.,yPo-T1PRETUy))
c
            CALL HFNT(L1PRETUPnr)
         ELSEIF(iType.EQ.L1PREmuon.OR.
     &           iType.EQ.L1PREpxmuon)  THEN ! muon
            CALL L1MUOPO(MePo,iTrk,xPo,yPo,zPo)
c
            L1PRETUType  = iType
            L1PRETUTrk   = MIN(iTrk,1000)
            CALL l1cpart(OMTRA_TOPP(iTrk),L1PRETUTraID,cName)
            T1PRETUThre  = 0.
            iPoPo = MePo+L1MEpoint(1)+L1POreg   ! point in MU3
            T1PRETUdx    = T1MEstor(iPoPo+L1GEOINFsx)*0.5
            T1PRETUx     = T1MEstor(iPoPo+L1GEOINFx0)+T1PRETUdx
            T1PRETUdy    = T1MEstor(iPoPo+L1GEOINFsy)*0.5
            T1PRETUy     = T1MEstor(iPoPo+L1GEOINFy0)+T1PRETUdy
            T1PRETUE     = 0.
            T1PRETUEXp   = 0.
            T1PRETUEXm   = 0.
            T1PRETUEYp   = 0.
            T1PRETUEYm   = 0.
            T1PRETUdxCOG = 0.
            T1PRETUdyCOG = 0.
            T1PRETUETrk  = 0.
            T1PRETUdTRKx = MAX(-40.,MIN(40.,xPo-T1PRETUx))
            T1PRETUdTRKy = MAX(-40.,MIN(40.,yPo-T1PRETUy))
c
            CALL HFNT(L1PRETUPnr)
         ELSE
c           ---  HighPt part here...
         ENDIF
      ENDIF
c
      RETURN
c
      END



