*-- Author :    Rainer Mankel   08/05/95

      subroutine prhfit()

*     **** print information for reconstructed hits in table rhit
*     **** Parameters:
*     ****   hfit1, hfit2  - range of rows in table hfit
*     ****   rt          - associated reconstructed track
*     ****   rs          - associated reconstructed segment
*     ****   hit         - associated hit (hitb)
*     ****   pl          - associated plane
*     ****   sl          - associated superlayer

*     **** called by KUIP

      implicit none
#include "arte/Arte.fi"

      integer rh, rh1, rh2, nprint, hit, rt, sl, ipl, pl, nch, rs, 
     +     hit_ass, hb, indhb, iihb, iirh, indrh
      character*1 cresp
      character*80 chopt
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/RTRA.fi"
#include "auto/RHIT.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/RTRA.ff"
#include "auto/RHIT.ff"

*     **** parameters
      call kugeti(rh1)
      call kugeti(rh2)
      call kugeti(rt  )
      call kugeti(rs  )
      call kugeti(hit)
      call kugeti(pl  )
      call kugeti(sl  )
      call kugetc(chopt,nch)

*     **** fixup
      if (jrhit.le.0) then
         call mewarn('prhfit: table RHIT is not booked')
         go to 999
      endif

      if (rh2.eq.0) rh2 = rh1
      if (rh1.eq.0) then
       rh1 = 1
       rh2 = iq(jrhit+2)
      endif
      rh1 = max(1,rh1)
      rh2 = min(rh2,iq(jrhit+2))

      nprint = 0

      if (index(chopt,'R').eq.0) then
*        **** print as stored in RHIT table
         do 10 rh=rh1,rh2
            if (rt.gt.0.and.irhit_rtra(rh).ne.rt) go to 10
            if (rs.gt.0.and.orhit_rseg(rh).ne.rs) go to 10
            ipl = ihitb_gede(orhit_hitb(rh))
            if (pl.gt.0.and.ipl.ne.pl) go to 10
            if (sl.gt.0) then
               if (ipl.ge.1.and.ipl.le.iq(jgede+2)) then
                  if (ogede_gesl(ipl).ne.sl) go to 10
               endif
            endif
            if (hit.ne.0.and.orhit_hitb(rh).ne.hit) go to 10
            
            if (orhit_hitb(rh).gt.0
     +           .and.orhit_hitb(rh).lt.iq(jhitb+2))
     +           then
               hit_ass = orhit_hitb(rh)
            else
               hit_ass = 0
            endif

            nprint = nprint + 1
            if (mod(nprint,10).eq.1) then
*              **** header
               write(* ,'(a6,5a8,a10,2a8,4a6,a8)')
     +              'ihf','z','x','y','tx','ty','1/p','q','ipl','rt',
     +              'rs','ih','q(hitb)'
            endif
            
            write(* ,'(i6,5f8.2,e10.2,f8.4,4i6,f8.4)')
     +           rh,fhitb_z(orhit_hitb(rh)),frhit_x(rh),
     +           frhit_y(rh),
     +           frhit_tx(rh),frhit_ty(rh),frhit_p(rh),
     +           frhit_q(rh),
     +           ihitb_gede(orhit_hitb(rh)),irhit_rtra(rh),
     +           orhit_rseg(rh),orhit_hitb(rh),fhitb_q(hit_ass)
            if (mod(nprint,100).eq.0) then
               print *,' <any key to continue>'
               read(*,'(a1)') cresp
               if (cresp.eq.'q'.or.cresp.eq.'Q') go to 999
            endif
 10      continue               ! rh loop
      else
*        **** print as located by relation
         if (jrtra.eq.0) go to 999
         if (rt.le.0.or.rt.gt.iq(jrtra+2)) go to 999
         do 20 iihb=1,9999      ! loop over related hitb
            if (iihb.eq.1) then
               indhb = prtra_hitb(rt)
            else
               indhb = xrtra_hitb(indhb)
            endif
            if (indhb.eq.0) go to 21
            hb = mrtra_hitb(indhb)
            if (pl.gt.0.and.ihitb_gede(hb).ne.pl) go to 20
            if (sl.gt.0.and.ogede_gesl(ihitb_gede(hb)).ne.sl) go to 20

            do 30 iirh=1,999    ! loop over related rhit
               if (iirh.eq.1) then
                  indrh = phitb_rhit(hb)
               else
                  indrh = xhitb_rhit(indrh)
               endif
               if (indrh.eq.0) go to 31
               rh = mhitb_rhit(indrh)
               if (irhit_rtra(rh).ne.rt) go to 30

               if (rs.gt.0.and.orhit_rseg(rh).ne.rs) go to 30

               nprint = nprint + 1
               if (mod(nprint,10).eq.1) then
*                 **** header
                  write(* ,'(a6,5a8,a10,2a8,4a6,a8)')
     +                 'ihf','z','x','y','tx','ty','1/p','q','ipl','rt',
     +                 'rs','ih','q(hitb)'
               endif
            
               write(* ,'(i6,5f8.2,e10.2,f8.4,4i6,f8.4)')
     +              rh,fhitb_z(orhit_hitb(rh)),frhit_x(rh),
     +              frhit_y(rh),
     +              frhit_tx(rh),frhit_ty(rh),frhit_p(rh),
     +              frhit_q(rh),
     +              ihitb_gede(orhit_hitb(rh)),irhit_rtra(rh),
     +              orhit_rseg(rh),orhit_hitb(rh),fhitb_q(hit_ass)
               if (mod(nprint,100).eq.0) then
                  print *,' <any key to continue>'
                  read(*,'(a1)') cresp
                  if (cresp.eq.'q'.or.cresp.eq.'Q') go to 999
               endif
 30         continue
 31         continue

 20      continue
 21      continue
      endif

 999  end

