#include <math.h>

#include "marple/RcMatchFlag.hh"

RcMatchFlag::RcMatchFlag() : _bitvalue(0)
{
  this->operator = ( 11111);
}

RcMatchFlag::RcMatchFlag(int iflag) : _bitvalue(0)
{
  if( iflag == 0 ) iflag = 11111;

  // ukknown value
  if( iflag >= 100000 )
    {
      iflag -=(int)floor(double(iflag+1)/100000)*100000; 
    }
  // x coordinate
  if( iflag >= 10000 )
    {
      mark_X();
      iflag -=(int)floor(double(iflag+1)/10000)*10000;
    }
  // y coordinate
  if( iflag >= 1000  )
    {
      mark_Y();
      iflag -=(int)floor(double(iflag+1)/1000)*1000;
    }
  // tx coordinate
  if( iflag >= 100   )
    {
      mark_TX();
      iflag -=(int)floor(double(iflag+1)/100)*100;
    }
  // ty coordinate
  if( iflag >= 10 )
    {
      mark_TY();
      iflag -=(int)floor(double(iflag+1)/10)*10;
    }
  // pe coordinate
  if( iflag >= 1)
    {
      mark_PE();
    }
  return;
}
// -------------------------------------------------------
RcMatchFlag & RcMatchFlag::operator = ( int iflag)
{
  RcMatchFlag tmp(iflag);
  _bitvalue = tmp.bitvalue();
  return *this;
}
// -------------------------------------------------------

RcMatchFlag::operator int() const  // conversion of integer
{
  int intflag = 0;
  if( ifmarked_X()  ) intflag += 10000;
  if( ifmarked_Y()  ) intflag +=  1000;
  if( ifmarked_TX() ) intflag +=   100;
  if( ifmarked_TY() ) intflag +=    10;
  if( ifmarked_PE() ) intflag +=     1;
  return intflag;
}

RcMatchFlag & RcMatchFlag::operator = ( const RcMatchFlag & flag)
{
  _bitvalue = flag.bitvalue();
  return *this;
}

int RcMatchFlag::Nvariables() const
{
  int ndim = 0;
  if( ifmarked_X()  ) ndim++;
  if( ifmarked_Y()  ) ndim++;
  if( ifmarked_TX() ) ndim++;
  if( ifmarked_TY() ) ndim++;
  if( ifmarked_PE() ) ndim++;
  return ndim;
}



ostream & operator << (ostream & os, const RcMatchFlag & flag)
{
  os << int(flag);
  return os;
}
