      subroutine dicell
*********************************************************
*
* Displays a cut view of OTR honeycomb cells in Prism framework.
*
* Only cells with sense wires are drawn.
* Only fully cross-sected cells are drawn.
*
* Alexander Lanyov              Oct 1999
* Updated for correlated noise  Apr 2000
*
* Introduction of 3D views: Andrey Moshkin    Jul 1997
*
*********************************************************
        implicit none

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "gean/gcflag.fi"
#include "auto/GEO.fi"
#include "auto/REC.fi"
#include "auto/MC.fi"
#include "auto/DIG.fi"
#include "pris/zmh.fi"
#include "pris/zgraf.fi"
#include "gean/ZGESL.fi"

        integer iwkid,i,l,isl,pl,pl1,pl2,nl,il,nw,iw,slnamh
        integer id,ihitb,status,channel,n,asd,jpl,iotdr
        integer nlay,lay,layold,sec,rhits,ind_rhit,irhit
        integer rseg0,rtra0,mtra0,k,out,ind_mimp,imimp,dx,dy
#define USE_SLT 1
#ifdef USE_SLT
        integer trigger0,track0
#endif

        real ri,ro,pit,dia,wn(4),rwire,rad,width,tmp
        real filcol,lincol,linwid,zmin,zmax
        real xoffoct(7),zoffoct(7),xr(40),yr(40),zr(40),xc(40),yc(40)
        real x,z,dz,x0,z0,zlay1,zlay2,zlay0,size

        logical showwire,showcell,some_shown,seen,hitfound,same_rseg

        character*4 slnam,chopt*10,c*100

        real              R(9),yn,yx,cutval,cutval1,cutval2,
     @                    xmin,xmax,ymin,ymax,zc1,zc2
        common /c_dicell/ R   ,yn,yx,cutval,cutval1,cutval2,
     @                    xmin,xmax,ymin,ymax,zc1,zc2

        integer otr_gede_status,otr_gede_channel

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/REC.ff"
#include "auto/MC.ff"
#include "auto/DIG.ff"

        data xoffoct/+1., +0.5, -0.5, -1., -0.5, +0.5, +1./
        data zoffoct/ 0., +0.5, +0.5,  0., -0.5, -0.5, +0./

        if (prisinit.eq.0) then
           write (*,*) ' '
           write (*,*) 'Error: Prism is not initialized!'
           write (*,*) 'Please initialize Prism with command DRAW.'
           write (*,*) ' '
           return
        end if

        call iselnt(nt_detzg)
c       call igsg(1)
        call isclip(1)

c Probably program should suggest some reasonable value for cutval?
        call kugetr(cutval)
        call kugetr(zc1)
        call kugetr(cutval2)
        call kugetr(zc2)

        call kugetr(filcol)
        call kugetr(lincol)
        call kugetr(linwid)
        call kugetc(slnam,l)
        call uctoh(slnam,slnamh,4,4)
        call kugetc(chopt,l)

        call kugeti(rseg0)
        call kugeti(mtra0)
        call kugeti(rtra0)
#ifdef USE_SLT
        call kugeti(trigger0)
        call kugeti(track0)
#endif

        if (rseg0.ne.0) then                          !  copy info from RSEG
           write (*,*) 'Taking data from RSEG',rseg0
           if (rseg0.lt.0 .or. rseg0.gt.nrseg()) then
              write (*,*) 'Error: RSEG',rseg0,' was not found.'
              return
           end if
           zc1 = frseg_zf(rseg0)
           zc2 = frseg_ze(rseg0)
           cutval1 = frseg_yf(rseg0)
           cutval2 = frseg_ye(rseg0)

c Display RSEG with highlighted color
           tmp = corszg
           corszg = 6.
           call di1rseg(rseg0,1,ngesl(),' ')
           corszg = tmp

        else if (rtra0.ne.0) then                     !  copy info from RTRA
           write (*,*) 'Taking data from RTRA',rtra0
           if (rtra0.lt.0 .or. rtra0.gt.nrtra()) then
              write (*,*) 'Error: RTRA',rtra0,' was not found.'
              return
           end if

c This does not work since RTRA_RHIT does not exist.
c           ind_rhit = prtra_rhit(rtra0)
c           do while (ind_rhit.ne.0)
c              irhit = mrtra_rhit(ind_rhit)
c              ind_rhit = xrtra_rhit(ind_rhit)
c              zc1 = -1000.
c              ihitb = orhit_hitb(irhit)
c              if (irhit.ne.0 .and. ihitb.ne.0) then
c                 if (zc1.lt.-999) then
c                    zc1 = fhitb_z(ihitb)
c                    cutval1 = frhit_y(irhit)
c                 end if
c                 zc2 = fhitb_z(ihitb)
c                 cutval2 = frhit_y(irhit)
c              end if
c           end do

           if (zc1.lt.-999 .or. zc1.eq.zc2) then
              write (*,*) 'Bad RTRA =',rtra0
              return
           end if

        else if (mtra0.ne.0) then                     !  copy info from MTRA
           write (*,*) 'Taking data from MTRA',mtra0
           if (mtra0.lt.0 .or. mtra0.gt.nmtra()) then
              write (*,*) 'Error: MTRA',mtra0,' was not found.'
              return
           end if

           zc1 = 100000.
           zc2 = -1000.
           ind_mimp = pmtra_mimp(mtra0)
           do while (ind_mimp.ne.0)
              imimp = mmtra_mimp(ind_mimp)
              ind_mimp = xmtra_mimp(ind_mimp)
              if (imimp.ne.0) then
                 if (fmimp_z(imimp).lt.zc1) then
                    zc1 = fmimp_z(imimp)
                    cutval1 = fmimp_y(imimp)
                 end if
                 if (fmimp_z(imimp).gt.zc2) then
                    zc2 = fmimp_z(imimp)
                    cutval2 = fmimp_y(imimp)
                 end if
              end if
           end do
           if (zc2.lt.-999. .or. zc1.eq.zc2) then
              write (*,*) 'Bad MTRA =',mtra0,', First Z =',zc1,
     @             ', Last Z =',zc2
              return
           end if

#ifdef USE_SLT
        else if (trigger0.ge.0 .or. track0.ge.0) then      !  copy info from SLT tracks
           write (*,*) 'Taking data from SLT trigger',trigger0,
     @          ', track',track0
           call disltcut(trigger0,track0,zc1,zc2,cutval1,cutval2)
           if (zc2.lt.-999. .or. zc1.eq.zc2) then
              write (*,*) 'Bad SLT trigger data'
              return
           end if
#endif

        else if (cutval2.lt.-9998.) then
           zc1 = 0.
           zc2 = 1000.
           cutval1 = cutval
           cutval2 = cutval
        else
           cutval1 = cutval
           if (zc1.eq.zc2) then
              write (*,*) 'Error: Z1 and Z2 are equal'
              return
           end if
        end if

        iwkid=1
        call igqwk(iwkid,'NTWN',wn)
        xmin=wn(1)
        xmax=wn(2)
        ymin=wn(3)
        ymax=wn(4)

        if (iviewzg.ge.9) then
	 c78 = 'DICELL: cannot display view'
	 call ch78bi(iviewzg)
         call me78sp('T')
         goto 999
	end if

        call igset('TXFP',-62.)  ! text font

c------------------------------------------------------ Loop on superlayers
        do isl=1,ngesl()
         pl1 = igesl_fpl(isl)
         pl2 = pl1 + igesl_npl(isl) - 1
         if (igesl_cmp(isl) .ne. lgesl_wch) pl2=-1
         if (slnam.ne.'    '.and.slnamh.ne.iq(hqgesl_name(isl)))
     @    pl2=-1

c------------------------------------------------------ Loop on planes
         do pl=pl1,pl2

          nl  = igede_nsl(pl)
          pit = fgede_pit(pl)
          dia = 0.1 * int(pit/0.174 + 0.5)  ! Diameter in cm
          ro  = pit/3.                      ! outer radius of hexagon
          ri  = 0.5 * dia                   ! inner radius of hexagon

          do k =1,9
           R(k)  = fgede_rot(k,pl)
          end do

c Probably here we should throw away some planes which cannot be
c displayed at the current screen?
c (to make program faster)

          lay = igede_lay(pl)
          sec = igede_sec(pl)

          zlay1 = 10000.
          zlay2 = 0.
          nlay = 0
          do jpl=pl1,pl2
             if (igede_lay(jpl).eq.lay) then
                zlay1 = min(zlay1,fgede_zmin(jpl))
                zlay2 = max(zlay2,fgede_zmax(jpl))
             end if
             nlay = max(nlay,igede_lay(jpl))
          end do
          zlay0 = 0.5*(zlay1 + zlay2)                ! mean Z for this layer
          z0 = 0.5*(fgede_zmin(pl) + fgede_zmax(pl)) ! mean Z for this GEDE
          
c Determine from what side to put additional information
c (like ASD number, etc.).
          if (lay.eq.1) then                  ! first stereolayer
             dz = -1.                         
          else if (lay.eq.nlay) then          ! last stereolayer
             dz = 1.                          
          else if (z0+0.01 .gt. zlay0) then   ! module is at greater Z
             dz = -1.                         
          else if (z0-0.01 .lt. zlay0) then   ! module is at smaller Z
             dz = 1.
          end if

c---------------------------------------------------- Loop on monolayers
          do il=1,nl
           yx  = fgede_ymin(pl)
           yn  = fgede_ymax(pl)
           nw = igede_nwi(il,pl)

c--------------------------------------------------- Loop on wires
           do iw=1,nw

c--------------------------------------------------- Loop on corners
            seen = .false.
            do i=1,7  ! corners of hexagon
             z = fgede_zfw(il,pl) + dia * zoffoct(i)
             x = fgede_xfw(il,pl) + pit * (iw-1 + xoffoct(i)/3.)
             call cell2win(x,z, xr(i),yr(i),out)
             if (out.eq.0) seen = .true.
             if (xr(i).eq.0. .and. yr(i).eq.0.) goto 99
            end do
            if (.not.seen) goto 99

c--------------------------------------------------- End of loop on corners

c            if (idebug.ne.0 .and. (iw.eq.1 .or. iw.eq.nw)) then
c             write (c78,
c     @        '('' dicell: Drawing pl='',i4,'' il='',i1,'', iw='',i2)')
c     @             pl,il,iw
c             call me78sp('T')
c            end if

cccc            filcol = cocevzg ! in Prism
            if (filcol.gt.0) then
             call igset('FACI',filcol)  ! fill area color index
             call igset('FAIS',1.)      ! fill area style index
             call ifa(7,xr,yr)          ! fill area
	    end if

            showwire = .false.
            if (abs(wn(4)-wn(3)) .lt. 30.) showwire = .true.

            showcell = .true.
            some_shown = .false.      ! if something is already shown

c============================================ Show status
c To do: different status - by different color
            if (index(chopt,'S').ne.0) then
               showcell = .false.

               status = otr_gede_status(pl, il, iw)
c               write (*,*) 'pl=',pl,' il=',il,' iw=',iw,' st=',status
               call igset('FAIS',1.) ! fill area style index

c status bits in Wax:
c   1 = mask files
c   2 = not used
c   4 = not used
c   8 = not used
c  16 = not used
c  32 = not used
c  64 = correlated noise in this event
c 128 = missing FED

               if (iand(status,255-1-64-128).ne.0.and.status.ne.-1) then
                  write (*,*) 'Unknown status',status,
     @                 ' of OTR channel pl=',pl,' il=',il,' iw=',iw
               endif

               if (status.eq.-1) then   ! not connected wire - background
                  call igset('FACI',0.)
                  call ifa(7,xr,yr)
               else if (iand(status,128).eq.128) then   ! channels with missing FED in this event - cyan
                  call igset('FACI',7.)
                  call ifa(7,xr,yr)
               else if (iand(status,64).eq.64) then ! channels with noise in this event - magenta
                  call igset('FACI',6.)
                  call ifa(7,xr,yr)
               else if (status.ne.0) then           ! bad channels - yellow
                  call igset('FACI',5.)
                  call ifa(7,xr,yr)
               else if (filcol.eq.0) then           ! good channels - green
                  call igset('FACI',3.)
                  call ifa(7,xr,yr)
               end if

            end if

c============================================ Show hits
            hitfound = .false.
            if (index(chopt,'H').ne.0) then
               showcell = .false.

c Look through all HITBs of this GEDE.
               id = (iw-1) + 32*(il-1)
               do ihitb=igede_hit1(pl),igede_hitl(pl)
                  if (mod(ihitb_chid(ihitb),128) .eq. id
     @                 .and. ihitb_gede(ihitb) .eq. pl) then

                     same_rseg = .false.
                     hitfound = .true.
                     rhits = 0
                     ind_rhit = phitb_rhit(ihitb)
                     do while (ind_rhit.ne.0)
                        irhit = mhitb_rhit(ind_rhit)
                        ind_rhit = xhitb_rhit(ind_rhit)
                        if (irhit.ne.0) rhits = rhits + 1

                        if (rseg0.ne.0
     @                      .and. orhit_rseg(irhit).eq.rseg0) then
                           same_rseg = .true.
                        end if

                     end do

                     if (rhits.eq.0) then
                        call igset('FACI',4.)          ! HITB - blue
                        call igset('FACI',cocehzg)
                     else
                        call igset('FACI',2.)          ! RHIT - red
                        call igset('FACI',cocerzg)
                        if (same_rseg) then
                           call igset('FACI',6.)       ! RHIT - highlight color
                        end if
                     end if

                     call igset('FAIS',1.)             ! fill area style index
                     call ifa(7,xr,yr)                 ! fill area

c If in current scale hit is too small to see,
c draw some visible point of some size
                     dx = max(xr(1),xr(2),xr(3),xr(4),xr(5),xr(6))
     @                   -min(xr(1),xr(2),xr(3),xr(4),xr(5),xr(6))
                     dy = max(yr(1),yr(2),yr(3),yr(4),yr(5),yr(6))
     @                   -min(yr(1),yr(2),yr(3),yr(4),yr(5),yr(6))

                     if (max(dx,dy) .lt.
     @                    min(xmax-xmin,ymax-ymin)/550.) then
                        rad =  min(xmax-xmin,ymax-ymin)/550.
                        n = 10
                        z0 = fgede_zfw(il,pl)
                        x0 = fgede_xfw(il,pl) + pit * (iw-1)
                        seen = .false.
                        do i=1,n
                           z = z0 + rad * sin(6.28318*(i-1)/(n-1))
                           x = x0 + rad * cos(6.28318*(i-1)/(n-1))
                           call cell2win(x,z, xc(i),yc(i),out)
                           if (out.eq.0) seen = .true.
                           if (xc(i).eq.0. .and. yc(i).eq.0.) goto 49
                        end do
                        if (.not.seen) goto 49
                        call ifa(n,xc,yc)
                     end if
 49                  continue

c--------------------------------------------------- Draw isochrone
                     if (index(chopt,'I').ne.0) then
                        n = 40
                        z0 = fgede_zfw(il,pl)
                        x0 = fgede_xfw(il,pl) + pit * (iw-1)
                        rad = fhitb_q(ihitb)
                        seen = .false.
                        do i=1,n
                           z = z0 + rad * sin(6.28318*(i-1)/(n-1))
                           x = x0 + rad * cos(6.28318*(i-1)/(n-1))
                           call cell2win(x,z, xc(i),yc(i),out)
                           if (out.eq.0) seen = .true.
                           if (xc(i).eq.0. .and. yc(i).eq.0.) goto 59
                        end do
                        if (.not.seen) goto 59
                        call igset('PLCI',1.)
                        rad =  min(xmax-xmin,ymax-ymin)/3.
                        size = max(1.,rad)
                        size = min(size,4.)
                        call igset('LWID',size)
                        call ipl(n,xc,yc)
c---------------------------------------------End of loop on points at isochrone
                     end if
 59                  continue
                  end if
               end do
            end if

c============================================ Show channel numbers
            if (index(chopt,'N').ne.0) then
               showcell = .false.
               showwire = .false.

               channel = otr_gede_channel(pl, il, iw)
c               write (*,*) 'pl=',pl,' il=',il,' iw=',iw,' ch=',channel
               n = mod(channel-1,16) + 1
               write (c,'(i2)') n
               if (c(1:1).eq.' ') c = c(2:)
               call igset('TXAL',23.)   ! alignment: center mid
               call igset('CHHE', 0.25) ! Character height
               call itx(0.5*(xr(1)+xr(4)),0.5*(yr(1)+yr(4)),c)
            end if

c============================================ Show ASD numbers
            if (index(chopt,'A').ne.0) then
               showcell = .false.

               channel = otr_gede_channel(pl, il, iw)
c               write (*,*) 'pl=',pl,' il=',il,' iw=',iw,' ch=',channel
               n = mod(channel-1,16) + 1
               if (n.eq.9) then
                  size = 1.
                  size = min(size, 0.04*abs(wn(4)-wn(3)))
                  if (index(chopt,'F').ne.0) then
                     size = min(size, 0.04*abs(wn(4)-wn(3)))
                     if (nl.gt.2) size = 0.5*size
                  end if
                  size = max(size, 0.35)
                  call igset('CHHE', size) ! Character height

                  if (dz.lt.0.) then                  ! put number to the left
                     call igset('TXAL',33.) ! alignment: right mid
                     z = fgede_zmin(pl) + 0.3 * dz * size
                  else                                ! put number to the right
                     call igset('TXAL',13.) ! alignment: left mid
                     z = fgede_zmax(pl) + 0.5 * dz * size
                  end if

                  asd = (channel-1)/16 + 1
                  if (index(chopt,'F').ne.0) then
                     call igset('TANG', 90.) ! text angle
                     call igset('TXAL',23.) ! alignment: center mid
                     write (c,'(i1,''-'',i2.2,''-'',i2.2)') lay,sec,asd
                     if (dz.gt.0) then
                        z = z + 0.4*size
                     end if
                     call itx(z,0.5*(yr(1)+yr(4)),c)
                     call igset('TANG', 0.) ! text angle
                  else
                     write (c,'(i2)') asd
                     if (c(1:1).eq.' ') c = c(2:)
                     call itx(z,0.5*(yr(1)+yr(4)),c)
                  end if
               end if
            end if

c============================================ Show stereolayer orientation
            if (index(chopt,'L').ne.0) then
               if (lay.ne.layold) then
                  size = min(1.5, 0.05*abs(wn(4)-wn(3)))
                  call igset('CHHE', size) ! Character height
                  if (fgede_rot(2,pl) .gt. 0.04) then
                     c = '-'
                  else if (fgede_rot(2,pl) .lt. -0.04) then
                     c = '+'
                  else
                     c = '0'
                  end if
                  z = zlay0

                  x = wn(3)
                  call igset('TXAL',21.) ! alignment: center top
                  call itx(z,x,c)

                  x = wn(4)
                  call igset('TXAL',20.) ! alignment: center base
                  call itx(z,x,c)

               end if
               layold = lay
            end if

c============================================
            if (abs(wn(4)-wn(3)) .lt. 60.) showcell = .true.

            if (lincol.lt.0) then ! if user do not want to see cell borders
               showcell = .false.
               showwire = .false.
            end if

            if ((showcell .and. lincol.gt.0)
     @           .or. (hitfound.and.(ymax-ymin).lt.60.)) then
               if (lincol.gt.0) then
                  call igset('PLCI',lincol)
               else if (lincol.eq.0) then
                  lincol = cocebzg ! cell border in Prism
               end if
               if (lincol.ge.0) then
                  call igset('LWID',linwid)
                  call ipl(7,xr,yr)
               end if
            end if

            if (showwire) then
               rwire = 25.e-4
               if (abs(wn(4)-wn(3)) .lt. 20.) then
                  rwire = max(rwire, 0.0015*(wn(4)-wn(3)))
               end if
               call igarc(0.5*(xr(1)+xr(4)),0.5*(yr(1)+yr(4)),
     @              rwire,rwire,0.,0.) ! draw an arc - here circle
            end if

c============================================

99          continue
c--------------------------------------------------- 

           end do                 ! End of loop on wires
          end do                ! End of loop on monolayers

          if (index(chopt,'M').ne.0) then     ! show modules
             n = 0

             do il=1,nl
                n = n + 1
                xr(n) = fgede_xfw(il,pl)+pit*(igede_nwi(il,pl)-1)+pit/6.
                zr(n) = fgede_zmin(pl) + 0.5*(il-1)*dia
                n = n + 1
                xr(n) = xr(n-1) + pit/6.
                zr(n) = zr(n-1) + 0.5*dia
             end do
             n = n + 1
             xr(n) = xr(n-1) - pit/6.
             zr(n) = fgede_zmax(pl)

             do il=nl,1,-1
                n = n + 1
                xr(n) = fgede_xfw(il,pl) - pit/6.
                zr(n) = fgede_zmax(pl)
                n = n + 1
                xr(n) = xr(n-1) - pit/6.
                zr(n) = zr(n-1) - 0.5*dia
             end do
             n = n + 1
             xr(n) = xr(n-1) + pit/6.
             zr(n) = fgede_zmin(pl)

             n = n + 1
             xr(n) = xr(1)
             zr(n) = zr(1)

             if (n.gt.40)
     @            write (*,*) 'DICELL: dimension 40 is not enough !!!'

             seen = .false.
             do i=1,n
                call cell2win(xr(i),zr(i), xc(i),yc(i),out)
                if (out.eq.0) seen = .true.
                if (xc(i).eq.0. .and. yc(i).eq.0.) goto 79
             end do
             if (seen) then
                call igset('PLCI',4.)
                width = min(5., 0.5*550./(wn(2)-wn(1)))
                width = max(1., width)
                call igset('LWID',width)
                call ipl(n,xc,yc)
             end if
          end if
 79       continue
         end do                   ! End of loop on planes
        end do                ! End of loop on superlayers

c============================================ Show OTDR (dead regions area)
        if (index(chopt,'D').ne.0) then
           do iotdr = 1,notdr()
              pl = iotdr_gede(iotdr)
              yn = fgede_ymin(pl)
              yx = fgede_ymax(pl)
              do k =1,9
                 R(k)  = fgede_rot(k,pl)
              end do

              dia = 0.1 * int(fgede_pit(pl)/0.174 + 0.5) ! Diameter in cm

              zmin = fgede_zmin(pl)
              zmax = fgede_zmax(pl)
              if (igede_nsl(pl).gt.2) then
                 if (iotdr_sub(iotdr).eq.1) then
                    zmax = 0.5*(zmin+zmax)
                 else if (iotdr_sub(iotdr).eq.3) then
                    zmin = 0.5*(zmin+zmax)
                 end if
              end if

              xr(1) = fotdr_xmin(iotdr)
                                           zr(1) = zmin
              xr(2) = fotdr_xmin(iotdr)
                                           zr(2) = zmax
              xr(3) = fotdr_xmax(iotdr)
                                           zr(3) = zmax
              xr(4) = fotdr_xmax(iotdr)
                                           zr(4) = zmin
              xr(5) = xr(1)
                                           zr(5) = zr(1)

              seen = .false.
              do i=1,5
                 call cell2win(xr(i),zr(i), xc(i),yc(i),out)
                 if (out.eq.0) seen = .true.
                 if (xc(i).eq.0. .and. yc(i).eq.0.) goto 69
              end do
              if (.not.seen) goto 69
              write (*,*) 'Showing OTDR',iotdr
              call igset('PLCI',6.)
              call igset('LWID',3.)
              call ipl(5,xc,yc)
 69           continue
           end do
        end if

c---------------------------------------------------
 999    continue
        call iuwk(0,1)          ! Flush buffer

        if (cutval1.eq.cutval2) then
           write (*,*) ' Parameters used: CUTVAL=',cutval1
        else
           write (*,11) '   Parameters used: CUTVAL1',cutval1,'Z1',zc1
           write (*,11) '                    CUTVAL2',cutval2,'Z2',zc2
 11        format(a,' =',f8.2,' at ',a,' =',f8.2)

           write (*,12) 'left ',
     @          cutval1 + (cutval2-cutval1)*(xmin-zc1)/(zc2-zc1),xmin
           write (*,12) 'right',
     @          cutval1 + (cutval2-cutval1)*(xmax-zc1)/(zc2-zc1),xmax
 12        format(' At ',a,' picture edge: Cut =',f8.2,' ,  Z =',f9.2)

        end if

        return
        end

      subroutine dipro3(xp,yp,zp,xx,yy,zz)
*********************************************************
* Transforms 3-vector (xp,yp,zp) in lab. system
* to "screen system" (xx,yy,zz)
* (where xx,yy - screen corrdinates,
*           zz - orthogonal coordinate)
*********************************************************
      implicit none

#include "pris/zgraf.fi"

      real  xp,yp,zp,xx,yy,zz,xs,ys,zs
      real cp, sp, ct, st, radeg
      data radeg /57.29578/

      if (iviewzg.eq.1) then
*      **** xz view
       xx =  zp
       yy =  xp
       zz =  yp
      elseif (iviewzg.eq.0) then
*      **** xy view
       xx =  xp
       yy =  yp
       zz =  zp
      elseif (iviewzg.eq.2) then
*      **** yz view
       xx =  zp
       yy =  yp
       zz = -xp
      elseif (iviewzg.ge.3.and.iviewzg.le.6) then
       if (iviewzg.eq.3) then
*       **** spatial view
        ct = cos(thetzg / radeg)
        st = sin(thetzg / radeg)
        cp = cos(phizg / radeg)
        sp = sin(phizg / radeg)
       elseif (iviewzg.eq.4) then
*       **** isometric view
        ct = sqrt(2./3.)
        st = sqrt(1./3.)
        cp = sqrt(0.5)
        sp = cp
       elseif (iviewzg.eq.5) then
*       **** dimetric view
        ct = sqrt(0.8)
        st = sqrt(0.2)
        cp = sqrt(0.75)
        sp = 0.5

       elseif (iviewzg.eq.6) then
*       **** trimetric view
        ct = sqrt(5./6.)
        st = sqrt(1./6.)
        cp = sqrt(0.7)
        sp = sqrt(0.3)
       endif

*      **** scale factors
       xs = xp * fscalzg(1)
       ys = yp * fscalzg(2)
       zs = zp * fscalzg(3)
       xx =   cp      * xs            - sp      * zs
       yy = - st * sp * xs  + ct * ys - st * cp * zs
       zz =   ct * sp * xs  + st * ys + ct * cp * zs

      elseif (iviewzg.eq.7) then
*       **** x-stereo view (u)
       xx = zp
       yy = ucoszg * xp - usinzg * yp
       zz = usinzg * xp + ucoszg * yp
      elseif (iviewzg.eq.8) then
*      **** x-stereo view (v)
       xx = zp
       yy = ucoszg * xp + usinzg * yp
       zz =-usinzg * xp + ucoszg * yp
      endif

      return
      end

c alignment  0=10=left, 20=cent, 30=right, 0=base, 1=2=top, 3=mid' I D=0


c===========================================================================
      subroutine cell2win(x,z, xwin,ywin,out)
c----------------------------------------------------------------------
c Determine window coordinates of intersection of line in cell system
c Using the following values from common:
c
c    Filled from each GEDE:
c       R(i) - rotation matrix
c       yn,yx - fgede_xmin, fgede_xmax
c
c    Global constants (should be already filled here)
c       cutval*
c       xmin,xmax,ymin,ymax
c----------------------------------------------------------------------
      implicit none

      integer out
      real x,z,xwin,ywin,p,s,sc
      real xpn,ypn,zpn,xpx,ypx,zpx,x1,y1,z1,x2,y2,z2

        real              R(9),yn,yx,cutval,cutval1,cutval2,
     @                    xmin,xmax,ymin,ymax,zc1,zc2
        common /c_dicell/ R   ,yn,yx,cutval,cutval1,cutval2,
     @                    xmin,xmax,ymin,ymax,zc1,zc2

      out = 0
c lower end of tube
      xpn = R(1)*x + R(2)*yx + R(3)*z
      ypn = R(4)*x + R(5)*yx + R(6)*z
      zpn = R(7)*x + R(8)*yx + R(9)*z
      
c upper end of tube
      xpx = R(1)*x + R(2)*yn + R(3)*z
      ypx = R(4)*x + R(5)*yn + R(6)*z
      zpx = R(7)*x + R(8)*yn + R(9)*z
                   
      call dipro3(xpn,ypn,zpn,x1,y1,z1)
      call dipro3(xpx,ypx,zpx,x2,y2,z2)
      
      if (abs(cutval2-cutval1) .le. 1.e-7) then ! constant cut
         cutval = cutval1
c         write (*,*) 'cutval=',cutval,' (constant cut)'
      else if (abs(z2-z1) .le. 1.e-7) then      ! tube is parallel to the screen
c         write (*,*) 'tube is parallel to the screen!'
         goto 99
      else
         sc  = (zc2-zc1) / (cutval2-cutval1)
         s = (x2-x1) / (z2-z1)
         if (abs(sc-s) .le. 1.e-7) then
            write (*,*) 'track is parallel to tube!, sc=',sc,' s=',s
            write (*,*) 'x1=',x1,' x2=',x2,' z1=',z1,' z2=',z2
            write (*,*) ' zc1=',zc1,' zc2=',zc2
            goto 99             ! track is parallel to tube
         end if
         cutval = (x1 - zc1 + cutval1*sc - z1*s) / (sc-s)
c         write (*,*) 'cutval=',cutval
      end if

c     cutval = cutval1
      
      p = (cutval-z1)/(z2-z1)
      xwin = x1 + p*(x2-x1)
      ywin = y1 + p*(y2-y1)
      
      if (p.gt.1. .or. p.lt.0.) goto 99

      if (xwin .lt. xmin
     @.or.xwin .gt. xmax
     @.or.ywin .lt. ymin
     @.or.ywin .gt. ymax) out = 1
      
      return

c---------------- Not found or line does not intersect the screen
 99   xwin = 0.
      ywin = 0.
      return

      end
