*-- Author :    Rainer Mankel   03/01/96

      subroutine didraw()

*     **** (re)draw the picture, using parameters stored in
*     **** /zgrafr/ and /zgrafc/
*     **** may be called by kuip!
      implicit none

#include "arte/Arte.fi"
#include "arte/ArteFlag.fi"
#include "pris/zgraf.fi"
#include "pris/zmh.fi"
#include "auto/GEO.fi"
#include "auto/EV.fi"

      character*40 chopt
      integer islsta, islend, isl, idmc, idmcptr, pl, ipl, ipl_i,
     +        layer, sector, mv, rv, cmp, iwl, jauxpl, sl, idir
      integer ndetmx
      parameter (ndetmx=40000)
      integer ipldis(ndetmx),indexz(ndetmx),npldis,idrc,iipl,sl_rich,
     +     pl_target
      parameter (pl_target=9000001)
      real zpldis(ndetmx)
      real savecol
      logical init
      external dimag
      data init /.false./
      save init

      integer lenocc

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/EV.ff"

      if (prisinit.eq.0) call dicinit()

      c78 = '%PictureData:'
      call ch78bi(nevents)
      call ch78bi(ievhd_evt(1))
      call ch78bi(ievhd_run(1))
      call ch78bi(ievhd_exp(1))
      write (lpris,'(a)') c78(:lenocc(c78))

      if (jgesl.le.0) then
         call mewarn('didraw: table GESL is not booked')
         go to 999
      endif

      if (.not.init) then
         sl_rich = 0
         do sl=1,ngesl()        ! check if there is a RICH
            if (igesl_cmp(sl).eq.5) sl_rich = sl
         enddo
         init = .true.
      endif

*     **** get redraw parameters from /zgrafr/, /zgrafc/
      if (modezg.eq.2) then
         islsta = sl1zg
         islend = sl2zg
      else
         islsta = 1
         islend = iq(jgesl+2)
      endif
      pl = plzg
      idmc = mczg
      idrc = rczg
      mv = mvzg
      rv = rvzg
      layer = layerzg
      sector = sectorzg
      cmp = cmpzg

      
      chopt = choptzg

*     **** fixup
      if (islend.eq.0.and.islsta.ne.0) islend = islsta
      islsta = max(islsta,1)
      if (islend.eq.0) then
       islend = iq(jgesl+2)
      endif

      idmcptr = idmc

      call tusomh()

      call divpset()  ! check workstation viewport

*     **** clear workstation
      if (index(chopt,'A').eq.0) then
       call dinewp()
      endif

      call iselnt(nt_detzg)
      npldis = 0

      if (modezg.eq.1.or.modezg.eq.2) then
*        **** display superlayer range
         do 10 isl=islsta,islend
            if (modezg.eq.1) then
               if (isl.gt.scmxzg) go to 10
               if (.not.lscopzg(isl)) go to 10
            endif

            if (igesl_cmp(isl).le.4.or.igesl_cmp(isl).eq.6
     +           .or.igesl_cmp(isl).eq.8.or.igesl_cmp(isl).eq.9) then ! tracking superlayer
*              **** loop over planes
               do 20 iipl=1,9999
                  if (iipl.eq.1) then
                     jauxpl = pgesl_gede(isl)
                  else
                     jauxpl = xgesl_gede(jauxpl)
                  endif
                  if (jauxpl.eq.0) go to 21

                  ipl = mgesl_gede(jauxpl)

*                 **** check if plane belongs to sl
                  if (ogede_gesl(ipl).ne.isl) then
                     print *,' () didraw: ipl, isl, ogede_gesl(ipl)=',
     +                    ipl, isl, ogede_gesl(ipl)
                  endif

*                 **** check layer
                  if (layer.gt.0.and.igede_lay(ipl).ne.layer) go to 20
*                 **** check sector
                  if (sector.gt.0.and.igede_sec(ipl).ne.sector) go to 20
*                 **** check component
                  if (cmp.gt.0.and.igede_cmp(ipl).ne.cmp) go to 20

*                 **** store plane
                  if (npldis.eq.ndetmx) then
                     print *,' () didraw: npldis, ndetmx=',
     +                    npldis, ndetmx
                     stop
                  endif

                  npldis = npldis + 1
                  ipldis(npldis) = ipl
                  zpldis(npldis) = fgede_zmin(ipl)
 20            continue
 21            continue


            elseif (igesl_cmp(isl).eq.7
     +              .or.(igesl_cmp(isl).ge.13
     +                   .and.igesl_cmp(isl).le.14)) then ! CAL
               npldis = npldis + 1
               ipldis(npldis) = 1000000 + isl ! store sl for ECAL
               zpldis(npldis) = fgesl_z1(isl)
            endif

            if (lwallzg) then
*           **** loop over walls
               do 40 iipl=1,igesl_nwl(isl)
                  if (iipl.eq.1) then
                     jauxpl = pgesl_gwal(isl)
                  else
                     jauxpl = xgesl_gwal(jauxpl)
                  endif
                  if (jauxpl.eq.0) stop ' didraw: jauxwl zero '
                  iwl = mgesl_gwal(jauxpl)

*                 **** check if wall belongs to sl
                  if (ogwal_gesl(iwl).ne.isl) then
                     print *,' () didraw: iwl, isl, ogede_gesl(iwl)=',
     +                    iwl, isl, ogede_gesl(iwl)
                  endif

*                 **** check component
                  if (cmp.gt.0.and.igesl_cmp(isl).ne.cmp) go to 40

*                 **** store wall as plane with negative sign
                  if (npldis.eq.ndetmx) then
                     print *,' () didraw: npldis, ndetmx=', npldis, 
     +                    ndetmx
                     stop
                  endif

                  npldis = npldis + 1
                  ipldis(npldis) = -iwl ! store wall with negative id
                  zpldis(npldis) = 0.5 *
     +                 (fgwal_zmin(iwl) + fgwal_zmax(iwl))

 40            continue
            endif

 10      continue


*        **** add the target
         if (ltargzg) then
            if (npldis.eq.ndetmx) then
               print *,' () didraw: npldis, ndetmx=', npldis, ndetmx
               stop
            endif
            npldis = npldis + 1
            ipldis(npldis) = pl_target ! use target placeholder
            zpldis(npldis) = -10.
         endif

*        **** sort planes according to z
         if (abs(phizg).lt.90..or.abs(phizg).gt.270.) then
            idir = idirzg
         else
            idir = -idirzg
         endif
         call sortzv(zpldis,indexz,npldis,+1,idir+1,0)

*        **** magnet
         if (lmagnetzg) call dimag()

*        **** RICH
         if (.not.lwallzg.and.sl_rich.gt.0) then
            if (lscopzg(sl_rich)) call dirich()
         endif
         if (sl_rich.gt.0) then
            if (iviewzg.eq.11) call diring(sl_rich)
         endif

*        **** display planes
         do 30 ipl_i=1,npldis
            ipl = ipldis(indexz(ipl_i))
            if (ipl.lt.1000000) then
               if (ipl.gt.0) then
                  isl = ogede_gesl(ipl)
                  if (lplanzg) call diplab(ipl,chopt)
                  if (lcellzg) call dicellv(ipl)
                  call dihit (ipl,0,idmc,chopt)

                  if (index(chopt,'G').ne.0.or.lmimpzg)
     +                 call dighit(isl,ipl,idmc,chopt)
               else
                  call diwall(-ipl,chopt)
               endif
            elseif (ipl.lt.2000000) then
               isl = mod(ipl,1000000)
               if (lgcalzg) call diplac(isl,chopt) ! display ECAL blocks
               if (lwirezg) call dihitc(isl,0,idmc,chopt)
               if (lrcclzg) then ! display reconstructed clusters
                  savecol = cocebzg
                  if (lwirezg) then 
                     cocebzg = 6.
                  endif
                  call dirccl(isl,0,idmc,chopt)
                  cocebzg = savecol
               endif
***

               if (lmimpzg) call dimcal(isl,idmc,chopt)
            elseif (ipl.eq.pl_target) then
               call ditarg(' ')
            endif
 30      continue

*        **** MC particles
         if (index(chopt,'M').gt.0.or.lmczg)
     +        call dimc(idmc,mv,islsta,islend,chopt)

*        **** MC vertices
         if (index(chopt,'V').gt.0) then
            call dimv(idmc,mv,chopt)
*            call dirv(0,chopt)
         endif

*        **** SLT information
         if (lsltzg) call dislt

*        **** reconstructed tracks ...
         if (lrczg.or.index(chopt,'T').gt.0)
     +        call dirtra(idmc,idrc,islsta,islend,chopt)

*        **** reconstructed segments
         if (lrsegzg) then
            call dirseg(idmc,idrc,islsta,islend,chopt)
         endif

         if (lrverzg) call dirv(0,chopt)

      elseif (modezg.eq.3) then
*        **** display single plane
         if (lplanzg) call diplab(pl,chopt)
         call dihit (pl,0,idmc,chopt)

         if (index(chopt,'G').ne.0.or.lmimpzg)
     +        call dighit(ogede_gesl(pl),pl,idmc,chopt)
      else
         print *,' () didraw: invalid redraw mode=', modezg
      endif

*     **** axes
      if (laxiszg.and.index(chopt,'X').eq.0
     +           .and.index(chopt,'A').eq.0) call diaxis(chopt)

*     **** header text
      if (lheaderzg.and.index(chopt,'H').eq.0
     +     .and.index(chopt,'A').eq.0) call dihead()

*     **** complete frame
      if (lframezg.and.index(chopt,'A').eq.0) call diedge(chopt)

*     **** update wk and go to alpha mode
      call iuwk(0,1)
      call igterm()

 999  end
