*CMZ :  4.06/02 19/10/96  14.28.35  by  Rainer Mankel
*CMZ :  4.04/01 19/03/96  13.27.44  by  Rainer Mankel
*CMZ :  4.04/00 18/01/96  13.54.55  by  Rainer Mankel
*-- Author :    Rainer Mankel   09/12/95

      subroutine difrset()

      implicit none
#include "pris/zgraf.fi"
#include "pris/zframe.fi"
*     **** set up the nt's with an effective display window
*     **** given by x1zg, x2zg, y1zg, y2zg

      real mx_c, my_c, h_c, scal_x, scal_y, off_x,
     +     off_y, xmean, xdiff, ymean, ydiff, aspect, input_aspect
      integer nt

      if (x1zg.ge.x2zg.or.y1zg.ge.y2zg) then
       print *,' () difrset: x1zg,x2zg,y1zg,y2zg=', x1zg,x2zg,y1zg,y2zg
       stop 'difrset'
      endif

*     **** for determination of usable screen (for nt) we adapt to
*     **** the current style
      if (lheaderzg) then
         h_c = h  ! header
      else
         h_c = 0. ! no header
      endif

      if (laxiszg.and.((iviewzg.ge.0.and.iviewzg.le.2).or.iviewzg.ge.7))
     +     then
         mx_c = mx ! axis
         my_c = my
      else
         mx_c = 0. ! no axis
         my_c = 0.
      endif

      if (laspectzg) then
*      **** tailor x1zg....y2zg to keep aspect ratio 1:0.7
       aspect = (b - h_c - my_c) / (1. - mx_c)
       input_aspect = (y2zg - y1zg) / (x2zg - x1zg)
       if (input_aspect.le.aspect) then ! adjust vertical width to aspect
          ymean = 0.5 * (y1zg + y2zg)
          ydiff = aspect * (x2zg - x1zg)
          y1zg = ymean - 0.5 * ydiff
          y2zg = ymean + 0.5 * ydiff
       else                     ! adjust horizontal width to aspect
          xmean = 0.5 * (x1zg + x2zg)
          xdiff = (y2zg - y1zg) / aspect
          x1zg = xmean - 0.5 * xdiff
          x2zg = xmean + 0.5 * xdiff
       endif
      endif

**      print *,' difrset: x1zg, x2zg=', x1zg, x2zg
**      print *,'          y1zg, y2zg=', y1zg, y2zg

*     **** set up transformation NDC -> WC
      scal_x = (x2zg - x1zg) / (a * (1. - mx_c))
      scal_y = (y2zg - y1zg) / (a * (b - h_c - my_c))
      off_x = x1zg - a * mx_c * scal_x
      off_y = y1zg - a * (my_c + c) * scal_y

*     **** calculate frame dimensions in WC
      mheadzg = a * h * scal_y
      mlabxzg = a * mx * scal_x
      mlabyzg = a * my * scal_y

      xminzg = off_x
      xmaxzg = off_x + a * scal_x
      yminzg = off_y + a * c * scal_y
      ymaxzg = off_y + a * (b + c) * scal_y

      uxzg = 0.01 * scal_x
      uyzg = 0.01 * scal_y

*     **** set up normalization transformations
      nt = nt_framzg     ! display area for frame objects
      call iswn(nt,xminzg,xmaxzg,yminzg,ymaxzg)
      call isvp(nt,0.,a,a*c,a*(c+b))

*     **** set drawing NTs
      nt = nt_detzg             ! detector objects
      call iswn(nt,x1zg,x2zg,y1zg,y2zg)
      call isvp(nt,a*mx_c,a,a*(c+my_c),a*(c+b-h_c))
      ntzg = nt_framzg

*     **** set frame-based nt
      nt = nt_pictzg            ! frame-oriented objects
      call iswn(nt,0.,100.,0.,100.)
      call isvp(nt,0.,1.,0.,1.)

      call iselnt(nt_framzg)
      call igsa(1)
      call isclip(1)

*     **** The following normalization transforms are used by prism:

*     ****       nt_fram : world coordinates inside the rectangular frame
*     ****       nt_det  : world coordinates inside detector window
*     ****       nt_pict : picture-based coordinates in full display window


 999  end





