*-- Author :    Rainer Mankel   01/06/96

      subroutine ditraj(np,xin,yin,zin,oin,lwid,ltyp,spl,sort,
     +     charged,smk,txci,txt)

*     **** display MC track
      implicit none
      integer np    ! number of input points
      real xin(np)  ! projected x coordinates
      real yin(np)  ! projected y coordinates
      real zin(np)  ! world coordinates in z
      real oin(np)  ! ordering parameter
      real lwid     ! line width
      real ltyp     ! line type
      logical spl   ! true if spline option on
      logical sort  ! true if to be sorted
      logical charged ! true if charged particle
      integer smk   ! marker type
      real txci     ! text color index
      character*(*) txt ! text

#include "pris/zgraf.fi"
      integer nsomax, nprim
      parameter (nsomax=900)
      integer npoint, segment, segment_begin(3),
     +     segment_size(3), magflag(nsomax), ipoint,
     +     startpoint, endpoint, mfl(nsomax)
      real xxx(nsomax), yyy(nsomax)
      character*2 cgraph1,cgraph2

*     **** polyline/curve option, marker option
      if (spl) then
         if (smk.gt.0) then
            cgraph1 = 'CP'
            cgraph2 = 'LP'
         else
            cgraph1 = 'C'
            cgraph2 = 'L'
         endif
      else
         if (smk.gt.0) then
            cgraph1 = 'LP'
            cgraph2 = 'LP'
         else
            cgraph1 = 'L'
            cgraph2 = 'L'
         endif
      endif

*     **** number of points to be used
      npoint = np
      if (npoint.gt.nsomax) then
         print *,' () ditraj: overflowing npoint=',npoint
         npoint = nsomax
      endif

*     **** magnet flag
      do ipoint=1,npoint
         if (abs(zin(ipoint)-450.).lt.250.) then
            mfl(ipoint) = 1
         else
            mfl(ipoint) = 0
         endif
      enddo

      call ditsort(sort,npoint,xin,yin,oin,xxx,yyy,mfl)
      
*     **** invisible segments weedout
      startpoint = 0
      do 40 ipoint=1,npoint-1
         if (amax1(xxx(ipoint),xxx(ipoint+1)).lt.xminzg) go to 40
         if (amin1(xxx(ipoint),xxx(ipoint+1)).gt.xmaxzg) go to 40
         if (amax1(yyy(ipoint),yyy(ipoint+1)).lt.yminzg) go to 40
         if (amin1(yyy(ipoint),yyy(ipoint+1)).gt.ymaxzg) go to 40
         startpoint = ipoint
         go to 41
 40   continue
 41   continue
      if (startpoint.eq.0) go to 999 ! whole track invisible
      endpoint = startpoint +1
      do 50 ipoint=npoint-1,startpoint+1,-1
         if (amax1(xxx(ipoint),xxx(ipoint+1)).lt.xminzg) go to 50
         if (amin1(xxx(ipoint),xxx(ipoint+1)).gt.xmaxzg) go to 50
         if (amax1(yyy(ipoint),yyy(ipoint+1)).lt.yminzg) go to 50
         if (amin1(yyy(ipoint),yyy(ipoint+1)).gt.ymaxzg) go to 50
         endpoint = ipoint + 1
         go to 51
 50   continue
 51   continue

      if (startpoint.gt.(endpoint-1)) then
         print *,' () ditraj: startpoint,endpoint=',startpoint,endpoint
         go to 999
      endif

*     **** truncation of tracks leading outside frame
      if (xxx(startpoint).lt.xminzg) then
         yyy(startpoint) = yyy(startpoint) +
     +        (xminzg - xxx(startpoint)) *
     +        (yyy(startpoint+1)-yyy(startpoint)) /
     +        (xxx(startpoint+1)-xxx(startpoint))
         xxx(startpoint) = xminzg
      elseif (xxx(startpoint).gt.xmaxzg) then
         yyy(startpoint) = yyy(startpoint) +
     +        (xmaxzg - xxx(startpoint)) *
     +        (yyy(startpoint+1)-yyy(startpoint)) /
     +        (xxx(startpoint+1)-xxx(startpoint))
         xxx(startpoint) = xmaxzg
      endif

      if (xxx(endpoint).lt.xminzg) then
         yyy(endpoint) = yyy(endpoint) +
     +        (xminzg - xxx(endpoint)) *
     +        (yyy(endpoint-1)-yyy(endpoint)) /
     +        (xxx(endpoint-1)-xxx(endpoint))
         xxx(endpoint) = xminzg

      elseif (xxx(endpoint).gt.xmaxzg) then
         yyy(endpoint) = yyy(endpoint) +
     +        (xmaxzg - xxx(endpoint)) *
     +        (yyy(endpoint-1)-yyy(endpoint)) /
     +        (xxx(endpoint-1)-xxx(endpoint))
         xxx(endpoint) = xmaxzg
      endif

*     **** decompose track into three segments:
*     ****            1 - straight part in front of magnet area
*     ****            2 - curved part within magnet area
*     ****            3 - straight part beyond magnet area

      do segment=1,3            ! init segment pointers
         segment_begin(segment) = 0
         segment_size(segment) = 0
      enddo
      segment = 1
      segment_begin(1) = startpoint
      do ipoint=startpoint,endpoint
         if (charged.and.(segment.eq.1.and.magflag(ipoint).eq.1)) then
            segment_size(1) = segment_size(1) + 1 ! connect seg 1&2
            segment = 2
            segment_begin(segment) = ipoint
         elseif (segment.eq.2.and.magflag(ipoint).eq.0) then
            segment = 3
            segment_begin(segment) = ipoint - 1
            segment_size(3) = 1 ! connect 2 & 3
         endif
         segment_size(segment) = segment_size(segment) + 1
      enddo

*     **** draw the graph

*     **** set the variable drawing attributes
      call igset('LWID',lwid)
      call igset('LTYP',ltyp)
      if (smk.gt.0) call ismk(smk)   ! set marker type
      call ismksc(1.5)               ! marker scale factor

      if ((endpoint-startpoint+1).ge.2) then
*        **** draw segment in front of magnet (polyline)
 111     format(a20/100(/e12.4,e12.4))
         if (segment_size(1).ge.2) call igraph(segment_size(1),
     +        xxx(segment_begin(1)),yyy(segment_begin(1)),cgraph2)
*        **** draw segment inside magnet
         if (segment_size(2).ge.2) then
            call igraph(segment_size(2),
     +           xxx(segment_begin(2)),yyy(segment_begin(2)),cgraph1)
         endif

*        **** draw segment beyond magnet (polyline)
         if (segment_size(3).ge.2) call igraph(segment_size(3),
     +        xxx(segment_begin(3)),yyy(segment_begin(3)),cgraph2)

         if (txt.ne.' ') then      ! particle label option

*           **** draw name of particle right of largest-z mim
            call istxfp(0,2)
            call igset('TXAL',23.)
            call ischh(2.*uyzg)
            call igset('TXCI',txci)
            call itx(xxx(endpoint)+2.*uxzg,
     +           yyy(endpoint)+2.*uyzg,txt)
         endif
      endif

 999  end




      subroutine ditsort(sort,n,xin,yin,oin,xxx,yyy,mfl)
      
      implicit none
      logical sort     ! true if to be sorted
      integer n        ! number of points
      real xin(n)      ! x (in)
      real yin(n)      ! y (in)
      real oin(n)      ! sort parameter (in)
      real xxx(n)      ! x (out)
      real yyy(n)      ! y (out)
      integer mfl(n)   ! magnet flag (in/out)

      integer nsomax
      parameter (nsomax=900)
      integer mfl_buf(nsomax),ind(nsomax),ii

      if (n.gt.nsomax) then
         print *,' () ditsort: overflowing n=',n
         go to 999
      endif

      do ii=1,n                 ! initialize sort index
         ind(ii) = ii
      enddo

      if (sort) call sortzv(oin,ind,n,+1,0,0) ! sort

      do ii=1,n
         xxx(ii) = xin(ind(ii))
         yyy(ii) = yin(ind(ii))
      enddo

      if (sort) then
         do ii=1,n
            mfl_buf(ii) = mfl(ii)
         enddo
         do ii=1,n
            mfl(ii) = mfl_buf(ind(ii))
         enddo
      endif

 999  end
