// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
// Modifications:
// - Introduction of ::rotMatrix call     14-Aug-00 Wouter Hulsbergen
//

// class rangerGeWa
// abstract base class for Gede and Gwal

#ifndef rangerGeWa_HH
#define rangerGeWa_HH

#ifndef __ARTE_HH__
#include "arte/arte.hh"
#endif

class rangerGeWa {

public:
  rangerGeWa();                      // default constructor
  rangerGeWa(ArtePointer<GEDE> ge);  // constructor from GEDE plane
  rangerGeWa(ArtePointer<GWAL> gw);  // constructor from GWAL wall
  virtual ~rangerGeWa();
  virtual const int plNumber() {return 0;}   // return mangled plane number
  virtual inline const ArtePointer<GEDE> getGede() const =0;
  virtual inline const ArtePointer<GWAL> getGwal() const =0;
  virtual const int shp() const {return 0;};     // shape
  virtual float ms() const {return 0;}     // mult scattering
  virtual int cmp() const {return 0;}      // cmp
  virtual const float cos(){return 1;};    // cos of stereo angle
  virtual const float sin(){return 0;};    // sin of stereo angle
  virtual const float rot(int i)=0;          // rotation matrix
  virtual const float* rotmatrix() const=0;
  virtual const float xmin()=0;              // borders of total area
  virtual const float xmax()=0;
  virtual const float ymin()=0;
  virtual const float ymax()=0;
  virtual const float sxmin()=0;             // borders of sensitive area
  virtual const float sxmax()=0;
  virtual const float symin()=0;
  virtual const float symax()=0;
  virtual const float zmin()=0;
  virtual const float zmax()=0;
  virtual const float xmad()=0;
  virtual const float ymad()=0;
  virtual const float zmad()=0;
  virtual const char gvol(const int)=0;
};

#endif
