// 
//  Author:  Rainer Mankel                     Created:  25-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 


#ifndef RANGER_XPRO_HH
#define RANGER_XPRO_HH

#include <vector.h>
#include <set.h>
#include "rang/XWin.hh"

class rangerNavItem;
class rangerDomWin;

class rangerXPro {

public:
  rangerXPro(){};
  ~rangerXPro(){};

  vector<rangerXWin*>& xws() { return xWs;};
  void appXWin(rangerXWin* xwi) { xWs.push_back(xwi); };
  int xWinFill(rangerDomain* dom,rangerDomWin* win,
	       float z,double x,double tx);
  void xProInt(vector<rangerDomain*>& domains);
  void clr() { 
    for (vector<rangerXWin*>::iterator xwit=xWs.begin();
	 xwit != xWs.end(); ++xwit) {
      (*xwit)->clr();
    }
    navSet.erase(navSet.begin(),navSet.end());
  };
  void qptSet(int fti,double qpt) { ftLink=fti; qptEst=qpt; }; 
  int navig(const rangerDomWin* dw);
  double qpt() { return qptEst;};
  int ft() { return ftLink;};
  void dump(const int level=1);

private:
  int ftLink;
  set<rangerNavItem*> navSet;
  vector<rangerXWin*> xWs;
  double qptEst;
};
#endif
