// 
//  Author:  Alexander Spiridonov              Created:  31.05.99
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgextvmrse.C
//
//                     create VDS-MUON-RICH seeds for ranger-external
//
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include "arte/RSEG_cmp.hh"
#include "arte/arte.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"
#include "rang/zfextse.hh"


// Prototypes


extern "C" {
  void rgextvmrse_() {

// initialization
    
    zfextse_.N_ext_seed = 0; 

//                                      loop on segments in muon
 
    for( ArteTableIterator <RSEG> segmu; 
	 segmu.valid(); segmu.next() )
      {
	if( segmu->fit >= 0 && segmu->cmp & Rsegc::muon 
	    && (segmu->cmp & Rsegc::bitsign) == 0  )
//                                                                           )
	  {
//		    cout << "rgextvmrse : muon segment "  << segmu << endl;

//                                           loop on segnemts in VD
	    for( ArteTableIterator <RSEG> segvd;
		 segvd.valid(); segvd.next() )
	      {
		if( segvd->fit >= 0 && segvd->cmp & Rsegc::vxd 
		    && (segvd->cmp & Rsegc::bitsign)  == 0  )
//                                                                          )
		  { 	  
//	    cout << "rgextvmrse : vds segment "  << segvd << endl;

                    int OK_vdmu = 0;
		    float p_mu[5];
		    rgextvdmu(segvd,segmu,p_mu,OK_vdmu);
		    cout << "rgextvmrse : OK_vdmu "  << OK_vdmu << endl;

                    if(OK_vdmu)
		      {
//                                              loop on segments in rich
			for( ArteTableIterator <RSEG> segri;
			     segri.valid(); segri.next() )
			  {
			    if( segri->fit >= 0 && segri->cmp & Rsegc::rich
				&& (segri->cmp & Rsegc::bitsign)  == 0  )
			      {
				int OK_vdmuri = 0;
				int MC_vdmuri;
				cout << "rgextvmrse : rich segment "  
				     << segri << endl;
				rgextvdmuri
				  (segvd,segmu,segri,p_mu,OK_vdmuri,MC_vdmuri);
				cout << "rgextvmrse : OK_vdmuri "  
				     << OK_vdmuri << endl;
				
				if(OK_vdmuri && 
				   zfextse_.N_ext_seed < NMAX_SEED )
				  {
				    cout << "rgextvmrse : N_ext_seed " 
					 << zfextse_.N_ext_seed << endl;
                                    int seed;
                                    seed = zfextse_.N_ext_seed;

				    zfextse_.z_seed[seed] 
				      = zfparext_.z_match_mu;
				    
				    zfextse_.x_seed[seed] = p_mu[0];
				    zfextse_.y_seed[seed] = p_mu[1];
				    zfextse_.tx_seed[seed] = p_mu[2];
				    zfextse_.ty_seed[seed] = p_mu[3];
				    zfextse_.q_seed[seed] = p_mu[4];

//				    zfextse_.cov_seed[seed][0] = 0.9*0.9;
//				    zfextse_.cov_seed[seed][2] = 1.6*1.6;
				    zfextse_.cov_seed[seed][0] = 0.32*0.32;
				    zfextse_.cov_seed[seed][2] = 0.57*0.57;
				    zfextse_.cov_seed[seed][5] = 0.26e-6;
				    zfextse_.cov_seed[seed][9] = 0.49e-6;
				    zfextse_.cov_seed[seed][14] = p_mu[4]* 
				      p_mu[4] * 0.06 * 0.06;
				    zfextse_.seg_VDS[seed] = segvd.index(); 
				    zfextse_.seg_MUON[seed] = segmu.index(); 
				    zfextse_.seg_ECAL[seed] = 0; 
				    zfextse_.seg_RICH[seed] = segri.index(); 
				    zfextse_.seg_OT[seed] = 0; 
				    zfextse_.track_MC[seed] = MC_vdmuri; 

				      ++zfextse_.N_ext_seed;

				  }
			      }
			  }
			
		      }
		  }
	      }  
	    
	  }
      }
  }
}

