// 
//  Author:  Alexander Spiridonov              Created:  25.08.00
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
//  changed :
//  checK patt,magt,trit flags when set slt flag     01.10.00   A. Spiridonov
// 
// rgsltre.C
//
//       reconstruct tracks seeded by slt    
//
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include "arte/RSEG_cmp.hh"
#include "arte/arte.hh"
//#include "rang/rgExtDef.hh"
#include "rang/zfextse.hh"
#include "rang/zfparext.hh"

// Prototypes


extern "C" 
{  
  void rgsltget_(int& , float* );
  void tfextre_(const int&);
  void tftcren_(int&);
  float tfqptest_(float&, float&, float&);
  void rguniqa_();
  void rghlevnt_();
  void tfunrfr_();
  void rgdom_();
}

extern "C" void rgsltre_() 
{

// initialization

  static int FirstCall = 1;
  static float w_x,w_y,w_tx,w_ty;

  if(FirstCall)
    {
      rgdom_();
      FirstCall = 0;
      // s_x = 0.08
      // s_y = s_x * 12.
      // s_tx = s_x / 70.
      // s_ty = s_tx * 12.

      w_x = 156.25;
      w_y = 1.085;
      w_tx = 765625.;
      w_ty = 5317.;

    }                   

  rghlevnt_();

  int Ntrack;
  float parslt[400]; 
  rgsltget_(Ntrack, parslt);  

  //  rgsltget_(&Ntrack, parslt);

  if(Ntrack == 0) return;

  //cout << " ============================================== " << endl;
  //cout << " rgsltre.C : Ntrack "  << Ntrack
  //     << " x " << parslt[0] << " y " << parslt[1]
  //     << " tx " << parslt[2] << " ty " << parslt[3] << endl;
  //cout << " rgsltre.C : Ntrack "  << Ntrack
  //     << " x " << parslt[4] << " y " << parslt[5]
  //     << " tx " << parslt[6] << " ty " << parslt[7] << endl;

  for(int slt = 0; slt < Ntrack; ++slt)
    {

      //cout << " rgsltre.C : start slt " << slt << endl;

      for(int seed = 0; seed < 2; ++seed) 
	{ 
	int nrseg = 0;
        zfextse_.N_ext_seed = 0; 
	float zseed;     
	  
	if(seed == 0) {zseed = 702.;} //  seed planted in PC1
	if(seed == 1) {zseed = 851.;} //  seed planted in PC4
	      
	++zfextse_.N_ext_seed; 

	int L = slt * 4;
	zfextse_.z_seed[zfextse_.N_ext_seed-1] = zseed;
	zfextse_.x_seed[zfextse_.N_ext_seed-1] = parslt[L]+parslt[L+2]*zseed;
	zfextse_.y_seed[zfextse_.N_ext_seed-1] =parslt[L+1]+parslt[L+3]*zseed;
	zfextse_.tx_seed[zfextse_.N_ext_seed-1] = parslt[L+2];
	zfextse_.ty_seed[zfextse_.N_ext_seed-1] = parslt[L+3];
	zfextse_.q_seed[zfextse_.N_ext_seed-1] = 
	  - tfqptest_( zseed, zfextse_.x_seed[zfextse_.N_ext_seed-1],
		       zfextse_.tx_seed[zfextse_.N_ext_seed-1]) * 1.031;

	for(int j = 0; j < 15;++j)
	  {zfextse_.cov_seed[zfextse_.N_ext_seed-1][j] = 0;}
	
	zfextse_.cov_seed[zfextse_.N_ext_seed-1][0] = 6.;
	zfextse_.cov_seed[zfextse_.N_ext_seed-1][2] = 200.;
	zfextse_.cov_seed[zfextse_.N_ext_seed-1][5] = 0.000025;
	zfextse_.cov_seed[zfextse_.N_ext_seed-1][9] = 0.0001;

	
	//zfextse_.cov_seed[zfextse_.N_ext_seed-1][0] = 0.02;  // electron
	//zfextse_.cov_seed[zfextse_.N_ext_seed-1][2] = 0.8;
	//zfextse_.cov_seed[zfextse_.N_ext_seed-1][5] = 0.0000012;
	//zfextse_.cov_seed[zfextse_.N_ext_seed-1][9] = 0.00008;

	//zfextse_.cov_seed[zfextse_.N_ext_seed-1][0] = 0.03;  // muon
	//zfextse_.cov_seed[zfextse_.N_ext_seed-1][2] = 2.0;
	//zfextse_.cov_seed[zfextse_.N_ext_seed-1][5] = 0.0000012;
	//zfextse_.cov_seed[zfextse_.N_ext_seed-1][9] = 0.00012;

	int nrseg1 = ArteTable<RSEG>::nrow();

	if(seed == 0) {tfextre_(1);}  //  seed planted in PC1   
	if(seed == 1) {tfextre_(2);}  //  seed planted in PC4   

	int nrseg2 = ArteTable<RSEG>::nrow();
	
	if(nrseg2 == nrseg1 || seed == 1) continue;

	//cout << " rgsltre.C : slt " << slt << " Ntrack " << Ntrack  
	//     << " N_ext " << zfextse_.N_ext_seed << " nrseg1 " << nrseg1
	//     << " nrseg2 " << nrseg2 << endl;

	// check of rseg OK
	float chi2 = 20.;                                 // maximal chi2
	for (int iseg = nrseg1 + 1; iseg <= nrseg2; ++iseg)
	  {
	    ArtePointer<RSEG> rseg(iseg);
	    if( !((rseg)->cmp & Rsegc::patt) ) continue;  // no PC
	    if((rseg)->nhit < 20 ) continue;              // no hits

	    float xt = rseg->xf + rseg->txf * ( zseed - rseg->zf );
	    float yt = rseg->yf + rseg->tyf * ( zseed - rseg->zf );
	    float txt = rseg->txf;
	    float tyt = rseg->tyf;
	    float chix = zfextse_.x_seed[zfextse_.N_ext_seed-1] - xt; 
	    float chiy = zfextse_.y_seed[zfextse_.N_ext_seed-1] - yt; 
	    float chitx = zfextse_.tx_seed[zfextse_.N_ext_seed-1] - txt; 
	    float chity = zfextse_.ty_seed[zfextse_.N_ext_seed-1] - tyt; 
	    float chit = w_x * chix * chix + w_y * chiy * chiy
	      + w_tx * chitx * chitx + w_ty * chity * chity;
	    if(chit <= chi2) { nrseg = iseg; chi2 = chit;}

	  }

	if(nrseg > 0) break;          //    first seed was OK
 
	//cout << " rgsltre.C : slt " << slt << " nrseg " << nrseg 
	//     << " chi2 " << chi2 << endl; 

	}            // end seed

    }

  int istat;
  tftcren_(istat);
  rguniqa_();
  tfunrfr_();

  // set rsegc_slt bit flag

  for ( ArteTable<RSEG>::iterator rseg = ArteTable<RSEG>::begin();
        rseg != ArteTable<RSEG>::end(); ++rseg ) 
    {
      if( (*rseg)->cmp & Rsegc::bitsign || (*rseg)->fit != 0
	  || !( (*rseg)->cmp & Rsegc::patt || (*rseg)->cmp & Rsegc::trit 
	  || (*rseg)->cmp & Rsegc::magt ) )  continue;
      
      //cout << " rgsltre : set slt flag to rseg " << *rseg << endl;

      (*rseg)->cmp |=  Rsegc::slt;

    }

}
