
*#define EXT_DEBUG
*#define EXT_TEST

*-- Author :    A.Spiridonov    02/06/99
*   changed:
*   remove nonmodular geometry                   26/08/00  A. Spiridonov   
*   new parameter seed                           27/08/00  A. Spiridonov 
*
      subroutine tfextpro(seed,ift1,direction,istat)
*
*     3D external-seed-follow in TC chambers of all alive seeds in /zf/  
*
      implicit none

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#include "rang/zfpar_ext.fi"
#include "rang/zdomain.fi"
#include "rang/zplx.fi"
#include "arte/Arte.fi"
      integer nmax,seed
      parameter (nmax=30)
      integer target_vec(nmax),n_target,tumchit,domlay,dlnext
      integer ift1,ift,izf,ipl,icycle,method,ncan,ii,jj,
     +        zone,iplnext,imust,izfnew,nhl,nhlmx,ihl,dom
      real x_pred,y_pred,dx_window,dy_window,dz,diff_x,window_size
      parameter (nhlmx=100)
      integer hl(nhlmx),nca_now,to_be_grown,direction,istat
      logical continued

      integer dlold, precold, dompointer, rgdomnb, rgdldom, rgdlwin
      real xmin,xmax,ymin,ymax,zdom
      real rgzlay, rgzdom

#include "rang/descend.fi"
       
      logical electron

      integer mcout
      real fracout

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "rang/sfdef.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "rang/sf.fi"


**      diag_level = 5

      dlold = 0
      precold = 0

*     **** loop over growth cycles
      istat = 0

      do ii=ift1,ncamx
         descend(ii)=0
      end do
*
      do 10 icycle=1,99

*      **** loop over present number of track candidates

         nca_now = nca_ft
         begin_ft = nca_ft + 1
         to_be_grown = 0
         do 20 ift=ift1,nca_now
            if (.not.alive_ft(ift)) go to 20
            if (mature_ft(ift))     go to 20
  
            if(descend(ift).ne.0) then     
               ift_descend = descend(ift)
            else
               ift_descend = ift
            end if

            to_be_grown = to_be_grown + 1

            if (diag_level.ge.5) then
               print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
               print *,' << track candidate ', ift, '             <<'
               print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
            endif

*           **** loop over planes in zone

            izf = last_ft(ift)
            ipl = plane_zf(izf)
            domlay = domlay_zf(izf)
            zone = fault_zf(izf) + 1
            ncan = 0
            continued = .false.
            method = 1          ! 3D    tracking

            if (diag_level.ge.6) then
               print *,' tftcpro: call tfdzone for domlay=', domlay,
     +              '  zone=', zone
            endif

            n_target = 0
            if(seed.eq.3.or.seed.eq.4) 
     +      call rgzone(domlay,method-1,zone,direction,4,4,1,nmax,  ! TC
     +           target_vec,n_target)
            if(seed.eq.1.or.seed.eq.2)
     +      call rgzone(domlay,method-1,zone,direction,3,3,1,nmax,  ! PC
     +           target_vec,n_target)
            if(diag_level.ge.5) then
              print *,' tfextpro:  domlay ',domlay
     +           ,' rgzone returns n_target=',n_target
            end if
*
            if (diag_level.ge.5) then
               print *,' zone=', zone
               print '(6((a),i5))',
     +              'tftcpro: for ipl=',ipl,' dl=',domlay,
     +              ' meth=',method,
     +              ' zone=',zone,
     +              ' nmax=',nmax,' we get n_target=', n_target
            endif
*
            do dom=1,maxdom_dm  ! reset prediction buffer
               filled_db(dom) = .false.
            enddo
*
            do 30 ii=1,n_target
               dlnext = target_vec(ii)
               if (diag_level.ge.5) print *,' tftcpro: next target='
     +              , dlnext
*           **** check if plane is within scope
*           **** check if window is intersected

               dz = rgzlay(dlnext) -  z_zf(izf)
               dompointer = rgdldom( dlnext)
               dom = rgdomnb( dompointer )
               zdom = rgzdom( dompointer )
**               print *,' tftcpro: next target in domnb=',dom,' z=',zdom
**               print *,' ..............window '
**               call rgwidmp(rgdlwin(dlnext))
**               call rgdldmp(dlnext)

**             if (.not.filled_db(dom)) call tfdbfill(dom,izf,istat)

****           check electron identification
         
               electron = electron_id(ift_descend)   
               electron = .false.
               if (.not.filled_db(dom)) then
                  x_pred = xx_zf(1,izf)+xx_zf(3,izf)*(zdom-z_zf(izf))
                  y_pred = xx_zf(2,izf)+xx_zf(4,izf)*(zdom-z_zf(izf))
 
                  filled_db(dom) = .true.
               end if

              if(diag_level.ge.5) then
                print '("tftcpro : dom,izf,x,y ",2i4,2(x,f8.3))'
     +                                ,dom,izf,x_pred,y_pred
              end if

*
               dx_window = 5.
               dy_window = 20.0

               call rgdlwbord(dlnext,xmin,xmax,ymin,ymax)

               if(diag_level.ge.5) then
                 print '("tftcpro : start test dlnext ",i9)',dlnext
                 print '("tftcpro : xy ",4(x,f8.3))'
     +           ,(xmin-dx_window),(xmax+dx_window)
     +           ,(ymin-dy_window),(ymax+dy_window)
               end if
               if (x_pred.lt.(xmin-dx_window).or.
     +              x_pred.gt.(xmax+dx_window)) go to 30
               if (y_pred.lt.(ymin-dy_window).or.
     +              y_pred.gt.(ymax+dy_window)) go to 30

*              **** can/must plane found

               if(diag_level.ge.5) then
                 print *,'tfextpro : test OK'
               end if

               ncan = ncan + 1

*              **** loop over hits

               if (dlnext.ne.dlold.or.ift_preced(ift).ne.precold) then
                  dlold = dlnext
                  precold = ift_preced(ift)
                  nhl = 0
**                  print *,' tfextpro : call rghlcr...'
                  call rghlcrd(dlnext,3,dble(z_zf(izf)),
     +                 xx_zf(1,izf),xx_zf(2,izf),
     +                 xx_zf(3,izf),xx_zf(4,izf),
     +                 nhlmx,hl,nhl)
**                  print *,'tfextpro : .... nhl=',nhl
               endif

#ifdef EXT_DEBUG
                print '("tftcpro : nhl ",i4)',nhl
                print '(15(x,i4)/)',(hl(jj),jj=1,nhl)
                print '(15(x,i4)/)',(ihitb_gede(hl(jj)),jj=1,nhl)
                print '(15(x,i4)/)',(igede_cmp(ihitb_gede(hl(jj)))
     +                 ,jj=1,nhl)
                print '(15(f5.1)/)',(fhitb_x(hl(jj)),jj=1,nhl)
#endif

               if (diag_level.ge.6) print *,' tftcpro: hitlist nhl= ',
     +              nhl
               do 40 ihl=1,nhl

                  if (diag_level.ge.6) then
                     print *,' tftcpro: hitlist ihl=', ihl, 
     +                    ' hit=', hl(ihl),
     +                    ' imc=', tumchit(hl(ihl))
                  endif
                  iplnext = ihitb_gede(hl(ihl))
               
                  diff_x = fhitb_x(hl(ihl))
     +                 - (  cstot_plx(iplnext)
     +                 * (xx_zf(1,izf)
     +                 + xx_zf(3,izf) * (fhitb_z(hl(ihl)) - z_zf(izf)))
     +                 - sntot_plx(iplnext)
     +                 * (xx_zf(2,izf)
     +                 + xx_zf(4,izf) * (fhitb_z(hl(ihl)) - z_zf(izf))))
               
                  window_size = 2.
*
#ifdef EXT_DEBUG
*                  if (diag_level.ge.6) then
                     print *,' tftcpro: diff_x=',diff_x,
     +                    ' window_size=',window_size
*                  endif
#endif

                  izfnew = 0
                  if (abs(diff_x).lt.window_size) then

                     istat = 0

                     if (diag_level.ge.6) then
                       print *,' tftcpro: call tfextfil'
                     end if
                     call tfextfil(hl(ihl),dlnext,iplnext,ift,izf,izfnew
     +                    ,istat)
                     if (istat.le.-100) go to 999
                     if (istat.le.-1) go to 40
                     if (izfnew.gt.0) continued = .true.
**                     print *,' --> izfnew = ',izfnew
**                     if (izfnew.gt.0) print *,
**     +                    ' number of hits=',nhit_zf(izfnew)
                  endif
               
 40            continue         ! hits in hitlist
*
 30         continue            ! planes in zone
*

#ifdef EXT_TEST

               print *,' tfextpro: whitmin cut removed'

                  alive_ft(ift) = .false.
#else

*           **** allow fault on old candidate

            if (fault_zf(izf).lt.maxflt_ext_zfpar) then
               fault_zf(izf) = fault_zf(izf) + 1
               nfault_ft(ift) = nfault_ft(ift) + 1
            else
*              **** kill or freeze old candidate
               if (whit_zf(izf).lt.whitmin_ext_zfpar) then
                  alive_ft(ift) = .false.
               else
                  mature_ft(ift) = .true.
                  stat_ft(ift) = 6
               endif
            endif
#endif

            if (diag_level.ge.5) call tfl()
*
 20      continue
*
*       print * ,'                                      call tfeed'

         call tftcweed
*
         if (diag_level.ge.4) then
            print *,' **********************************************'
            print *,' *                                            *'
            print *,' *                                            *'
            print *,' *           E  N  D     O  F                 *'
            print *,' *                                            *'
            print *,' *           G  R  O  W  T  H                 *'
            print *,' *                                            *'
            print *,' *            C  Y  C  L  E                   *'
            print *,' *                                            *'
            print *,' *                                            *'
            print *,' **********************************************'
            call tfl()
            if (l_diag) call tfwait()
         endif

         if (to_be_grown.le.0) go to 11
*
 10   continue
*
      print *,' () tftcpro: loop ends ii=99'
      stop 'tftcpro'

 11   if (diag_level.ge.4) then
        call tfl()
        print *,' **** end growing of seed **** '
      endif

      if (l_diag) call tfwait()

**      diag_level = 0

 999  end

