*-- Author :    A. Spiridonov   01/06/99
*   changed :
*   new parameter seed                               27/08/00  A. Spiridonov

*#define EXT_DEBUG

      subroutine tfextre(seed)
*
*     track reconstruction in OT & IT by means
*     of propagation of external seeds 
*
*      seed=1 , seed planted in PC1, downstream propagation
*          =2 ,                 PC4, upstream
*          =3 ,                 TC1, downstream
*          =4 ,                 TC2, upstream 
*

      implicit none

#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#include "rang/zf.fi"
#include "rang/zdomain.fi"
#include "rang/ztripl.fi"
#include "rang/zcut.fi"
#include "pris/zpstat.fi"
#include "arte/ArteFlag.fi"
#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/RSEG.fi"
#include "arte/RSEG_cmp.fi"
#include "rang/descend.fi"
#include "rang/FIXtrit.hh"
#include "rang/zfextse.fi"
#include "rang/zfpar_ext.fi"
#include "rang/zfparext.fi"

      integer seed,ift,iiseg,ift1,ift2,nca_x,direction,
     +      begin_store,istat,nca_prep

      logical init

      save init
      data init /.false./

      integer muon1,muon2
      integer nh,nh_PC,imimp,jaux,imc,nhmimp,imcass,NRSEG_rec
      integer iseed,seg_seed
      real fracmc
      real dtx,dty,dtxi,dtyi

      equivalence ( pstat_gold(1,1),muon1 )
      equivalence ( pstat_gold(2,1),muon2 )

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/RSEG.ff"

******************************************************************
*
*     Organization of storage:
*
*           1                  |
*           .                  | x candidates
*           .                  |
*         nca_x                |
*           .                   |
*           .                   | y candidates, 3d candidates
*         nca_y                 |
*           .                    |
*           .                    | magnet seeds
*         nca_prep               |
*           .                     |
*           .                     | magnet candidates
*           .                     |
*
******************************************************************

      l_diag = .false.
      diag_level = 0

      call rginit()
      if (.not.l_rinit) call tfrinit() ! restricted init

**      call rghlevnt()                                      ! domain hits

      l_term = .false.
      lremzc = .false.

*     **** do the work

      if(N_ext_seed.le.0) go to 999

      NRSEG_rec = NRSEG()

*        do iiseg=1,NRSEG_rec
*          seg_PC_TC(iiseg) = 0
*        end do

      do 10 iiseg=1,N_ext_seed     ! loop over external seeds
        
         call tfclr()           ! clear p.r. buffer
         begin_ft = 1

*         print '("tfextre : TAKE EXTERNAL seed",i4 )',iiseg

         call tfextse(seed,iiseg,ift1,ift2,istat)    ! seed

*         print '("tfextre : ext seed",i4," istat=",i2)',iiseg,istat

          if(istat.lt.0) then
*            print *,'tfextre: ==== tfextse seed,ift1,ift2,istat=',
*     +              iiseg,ift1,ift2,istat
          end if

         direction = -1

         nca_prep = ift2        ! store new endpointer

         l_2dx = .false.
         l_2dy = .false.
         l_mag = .true.
         begin_ft = nca_prep + 1
         istat = 0

         if(seed.eq.2.or.seed.eq.4) call tfextpro(seed,ift1,-1,istat) ! upstream
         if(seed.eq.1.or.seed.eq.3) call tfextpro(seed,ift1,1,istat) ! downstream

*         print *,' tfextre: tftcpro returns istat=',istat

         if (istat.ge.0) then
         elseif (istat.le.-100) then
            go to 999           ! no further propagation
         elseif (istat.le.-1) then
            go to 10            ! terminate branch
         endif

         if (diag_level.ge.2) then
            call tfl()
            print *,' after tfextpro,before tfbest'
            call tfwait()
         endif
         begin_ft = nca_prep + 1
         call tfbest()
         if (diag_level.ge.3) then
            call tfl()
            print *,' after tfbest'
            call tfwait()
         endif

*        **** store loop
 9       continue

         begin_store = nca_prep + 1

         do 40 ift=begin_store,nca_ft
            if (alive_ft(ift)) then

              if (quality_ft(ift).lt.quality_ext_min) go to 40

#ifdef EXT_DEBUG
               print '(" tfextre.F : ift, qmin, q ",i4,2f8.3)'
     +                ,ift,quality_ext_min,quality_ft(ift)
#endif


              call tfsmfin(ift)   !    segment fit

              call tfstseg(ift)

*             OT segment of seed

              seg_OT(iiseg) = NRSEG()

#ifdef TC_TEST
              call tfremcse(NRSEG(),imc,fracmc)
              print '("tfextre : ======== stored seed,nseg,imc,fracmc "
     +        ,3i4,x,f7.2)'
     +                ,iiseg,NRSEG(),imc,fracmc
 
*              call tfprhs(NRSEG())

#endif

#ifdef rgExtHist
                call hf2
     +          (id_hist+524,frseg_xf(NRSEG()),frseg_yf(NRSEG()), 1.)
#endif


*     ****  set RBEG <----> REND relation for EXT-segments

              if(seg_VDS(iiseg).gt.0) then
                call mmbrel
     +          (jrsrs,seg_VDS(iiseg),NRSEG()) ! set relation VDS-seg
*                print '("tfextre : set relation RBEG-REND VDS OT",2i5 )'
*     +               ,seg_VDS(iiseg),NRSEG()
              end if

              if(seg_RICH(iiseg).gt.0) then
                call mmbrel
     +          (jrsrs,seg_RICH(iiseg),NRSEG()) ! set relation VDS-seg
*                print 
*     +          '("tfextre : set relation RBEG-REND RICH OT",2i5 )'
*     +          ,seg_RICH(iiseg),NRSEG()
              end if

              if(seg_ECAL(iiseg).gt.0) then
**                call mmbrel
**     +          (jrsrc,NRSEG(),seg_ECAL(iiseg)) ! set relation seg-ECAL
**                       ! relations swap
                call mmbrel
     +          (jrcrs,seg_ECAL(iiseg),NRSEG()) ! set relation seg-ECAL
*                print 
*     +          '("tfextre : set relation RBEG-REND OT CLUS",2i5 )'
*     +          ,NRSEG(),seg_ECAL(iiseg)
              end if

*     ***    try to find best segment and kill other
              if(iiseg.ge.2.and.seg_RICH(iiseg).gt.0
     +          .and.seg_ECAL(iiseg).gt.0)              then
                dtx = frseg_txf(seg_RICH(iiseg)) - frseg_txf(NRSEG())
                dty = frseg_tyf(seg_RICH(iiseg)) - frseg_tyf(NRSEG())
                do iseed=1,iiseg-1
                  seg_seed = seg_OT(iseed)
                  if(seg_seed.gt.0.and.seg_RICH(iseed).gt.0) then
                    if(iand(irseg_cmp(seg_seed),rsegc_bitsign).eq.0
     +                 .and.seg_ECAL(iiseg).eq.seg_ECAL(iseed)) 
     +                                                             then
                      dtxi = frseg_txf(seg_RICH(iseed)) 
     +                     - frseg_txf(seg_seed)
                      dtyi = frseg_tyf(seg_RICH(iseed)) 
     +                     - frseg_tyf(seg_seed)
                      if(dtx**2+dty**2.le.dtxi**2+dtyi**2) then
                        iq(iqrseg_cmp(seg_seed))=
     +                  ior(irseg_cmp(seg_seed),rsegc_bitsign)
                        print '("tfextre : kill seg_seed ",i4)',seg_seed
                      else 
                        iq(iqrseg_cmp(NRSEG()))=
     +                  ior(irseg_cmp(NRSEG()),rsegc_bitsign)
*                        print '("tfextre : kill NRSEG() ",i4)',NRSEG()
                      end if                           ! end test of dt**2
                    end if                             ! alive segment 
                  end if                               ! seg in OT
                end do                                 ! end do iseed
              end if                                   ! end fi iiseg.eq.2
      
              if (l_diag) call tfwait()

            endif
 40      continue

 10   continue                  !  end of loop on seeds

 999  return
      end
