*-- Author :    Rainer Mankel   01/04/96
*-- changed:    A.Spiridonov    20/03/98
*   check of slt_mode_zfpar when initialize           03/09/00  A. Spiridonov

#define NEWNAV
#define ZSEG_CUT

#ifdef NEWNAV
      subroutine tfmatripn(istat)
#else
      subroutine tfmatrip(istat)
#endif

*     **** mother routine for seed studies
      implicit none
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zf.fi"
#include "rang/ztripl.fi"
#include "rang/zcut.fi"
#include "pris/zpstat.fi"
#include "arte/ArteFlag.fi"

#include "rang/descend.fi"
#include "rang/FLAGWhit.hh"

#ifdef NEWNAV
      integer maxseed
      parameter (maxseed=50)
      integer vseed(maxseed)
      integer nseed
      integer jseed,jtabl,rgnavig,rgswin,win
#else
#include "rang/zdomain.fi"
#endif

      integer ntot,ngood,mc,ift,izf,nhits,clus,
     +      dl,dw,nca_x,dom,direction,pc,run_level,nca_y,n_good,
     +      begin_store,jft,ft_good,istat,nca_prep

      integer if_prep     

      real ef
      logical init, lstore

#ifdef NEWNAV
      integer maxtabl
      parameter (maxtabl=5)
      integer vtabl(maxtabl),dirtabl(maxtabl)
      integer ntabl
      integer itabl
      integer rgdlwin
#endif

      save init
      data init /.false./

******************************************************************
*
*     Organization of storage:
*
*           1                  |
*           .                  | x candidates
*           .                  |
*         nca_x                |
*           .                   |
*           .                   | y candidates, 3d candidates
*         nca_y                 |
*           .                    |
*           .                    | magnet seeds
*         nca_prep               |
*           .                     |
*           .                     | magnet candidates
*           .                     |
*
******************************************************************

      call rginit()
      if (.not.l_rinit) call tfrinit() ! restricted init

      l_term = .false.
      lremzc = .false.

*     **** should we clear the track bank ??

*     **** do the work
      if (.not.init) then
#ifdef NEWNAV
         if(slt_mode_zfpar.le.0) then
            call rgdom()        ! set up domain structure
         end if
#else
         call dmmain()          ! set up domain structure
#endif
         init = .true.
      endif

#ifdef NEWNAV
      if(slt_mode_zfpar.le.0) then
         call rghlevnt()
      end if
#else
      call dmhit(istat)         ! set domain hit buffer
      if (istat.le.-100) go to 999
#endif

**      print *,' tfmatrip: loop over pc'
**      call tfwait()

#ifdef NEWNAV
      call rgstabl(maxtabl,vtabl,dirtabl,ntabl)
**      print *,' rgstabl returns ntabl=',ntabl
      do itabl=1,ntabl
**      do itabl=2,2
         call tftripxn(vtabl(itabl),dirtabl(itabl))
         direction = dirtabl(itabl)


#else
         do pc=4,1,-3
**         do pc=4,4,-3
         dom = dom_dpc(pc)
         direction = dir_dpc(pc)
         call tftripx(dom)      ! construct seeds for domain 20
#endif
         do 10 clus=1,nclusx
**            print *,'--------------------------------------------'
**            print *,' propagate cluster ', clus
**            print *,'--------------------------------------------'

#ifdef NEWNAV
**            print *,' call rgmodls'
            call rgmondls(dl_set(trip1_clus(clus)),0)
**            print *,' after rgmodls'
#endif

            call tfclr()
            begin_ft = 1
#ifdef NEWNAV
            call tfpropcxn(clus,direction) ! propagate
#else
            call tfpropcx(clus,direction) ! propagate
#endif
            call tfbest()
            nca_x = nca_ft
            l_mag = .false.

            n_good = 0
            ft_good = 0
            do jft=1,nca_x
               if (alive_ft(jft)) then
                  if (quality_ft(jft).gt.qualmin_x_zfpar) then
                     n_good = n_good + 1
                     ft_good = jft
#ifdef NEWNAV
                     call rgmondls(domlay_zf(first_ft(jft)),1)
#endif
                  endif
               endif
            enddo

**            print *,' after horizontal tracking '
**            print *,' ............n_good =',n_good,' ft=',ft_good

            if (rlevel_zfpar.le.1) go to 9

*           **** vertical continuation
            begin_ft = nca_x + 1
            n_good = 0
            do 20 ift=1,nca_x
               if (alive_ft(ift)) then
                  if (quality_ft(ift).lt.qualmin_x_zfpar) then
                     alive_ft(ift) = .false.
                     go to 20
                  endif
                  if (diag_level.ge.3) then
                     call tflft(ift,' ')
                     call tfparmft(ift)
                     if (diag_level.ge.5)
     +                    print *,' before tfsasegx,ift=', ift
                     if (l_diag) call tfwait()
                  endif
#ifdef NEWNAV
**                  print *,' tfmatrip: call tfsasegxn for ift=',ift
                  call tfsasegxn(ift) ! save x-projection
**                  print *,' tfmatrip: tfsasegxn done'
                  dl = dl_set(s_trip(1,trip1_clus(clus))) ! get dom lyer
                  dw = rgdlwin(dl) ! get domain window

                  call tfcontyn(dw,vtabl(itabl),direction) 
                                   ! vertical completion
#else
                  call tfsasegx(ift) ! save x-projection
                  dl = dl_set(s_trip(1,trip1_clus(clus))) ! get dom lyer
                  dw = win_dl(dl) ! get domain window
                  call tfconty(dw) ! vertical completion
#endif

                  do jft=nca_x+1,nca_ft
                     if (alive_ft(jft)) then
                        if (quality_ft(jft).gt.qualmin_y_zfpar) then
                           n_good = n_good + 1
                        endif
                     endif
                  enddo

                  if (n_good.ge.1) go to 20

#ifndef ALTVERT
#ifdef NEWNAV
*                 **** try alternate vertical seeding set
                  do 50 jtabl=1,ntabl
                     if (jtabl.ne.itabl) then
**                        print *,' tfmatrip: alternative seed set',
**     +                       ' jtabl=',jtabl
                        call rgtabss(vtabl(jtabl),2,maxseed,vseed,nseed)
                        do jseed=1,nseed
                           win = rgswin(vseed(jseed))
                           if (rgnavig(win).eq.1) then
                              call tfcontyn(win,vtabl(jtabl),
     +                             dirtabl(jtabl))
                              go to 51
                           endif
                        enddo
                     endif
 50               continue
 51               continue
#else
                  if (dlx2_dlx.eq.4.and.dw_dlx(dlx2_dlx).ne.dw) then
                     call tfconty(dw_dlx(dlx2_dlx))
                  endif
                  if (dlx1_dlx.eq.1.and.dw_dlx(dlx1_dlx).ne.dw) then
                     call tfconty(dw_dlx(dlx1_dlx))
                  endif
#endif
#endif

                  do jft=nca_x+1,nca_ft
                     if (alive_ft(jft)) then
                        if (quality_ft(jft).gt.qualmin_y_zfpar) then
                           n_good = n_good + 1
                        endif
                     endif
                  enddo
**                  print *,' ............n_good =',n_good
               endif
 20         continue  ! x candidates

            begin_ft = nca_x + 1
            call tfbest()       ! optimize vertical

            nca_y = nca_ft

**            print *,' vertical completion done, n_good=',n_good

**            call tfwait()
**            if (n_good.eq.0) go to 10

*           **** 3D processing
            n_good = 0
            do 30 ift=nca_x+1,nca_y
               if (alive_ft(ift)) then
**                  print *,' vertical candidate ift,q=',
**     +                 ift,quality_ft(ift)
                  if (quality_ft(ift).lt.qualmin_y_zfpar) go to 30
                  n_good = n_good + 1
                  if (diag_level.ge.3) then
                     print *,' tfmatrip: vertical completion',
     +                    ' successful ',
     +                    ' ift=', ift
                     call tflft(ift,' ')
                     call tfparmft(ift)
                     if (l_diag) call tfwait()
                  endif
#ifdef OPTI
*                 **** check overlap with existing tracks
                  lstore = .true.
**                  call tfopti(ift,lstore)
                  if (lstore) then
#ifdef NEWNAV
                     call tfsmfin(ift)
#else
                     call tfsmfi(ift)
#endif
                     if (diag_level.ge.3) then
                        print *,' tfmatrip: after smoothing...'
                        call tflft(ift,' ')
                        call tfparmft(ift)
                     endif
                     call tfstor(ift)
                     if (l_diag) call tfwait()
                  endif
#else
#ifdef NEWNAV
                  call tfsmfin(ift)   
#else
                  call tfsmfi(ift)   
#endif
#endif
               endif
 30         continue            ! 3D process loop

**            print *,' 3D processing done, n_good=', n_good

**            if (n_good.le.0) go to 10

            if (rlevel_zfpar.le.2) go to 9

*           **** magnet continuation
            if_prep = 0
            do ift=nca_x+1,nca_y
               if (alive_ft(ift)) then
                  mature_ft(ift) = .false.
                  istat = 0
                  call tfmprep(ift,istat) ! prepare for magnet tracking
                  if(istat.eq.0) if_prep = 1
**                  call tflft(ift,' ')
**                  print *,' tfmatrip: before magnet, nca_ft=',nca_ft
**                  call tfwait()
               endif
            enddo

            if(if_prep.eq.0) go to 10
*            print *,' nca_x,nca_y ' ,nca_x,nca_y

            nca_prep = nca_ft   ! store new endpointer

            l_2dx = .false.
            l_2dy = .false.
            l_mag = .true.
            begin_ft = nca_prep + 1
            istat = 0
#ifdef NEWNAV
            call tfpropmn(nca_y+1,-1,istat)
#else
            call tfpropm(nca_y+1,-1,istat)
#endif
            if (istat.ge.0) then
            elseif (istat.le.-100) then
               go to 999        ! no further propagation
            elseif (istat.le.-1) then
               go to 10         ! terminate branch
            endif

            if (diag_level.ge.2) then
               call tfl()
               print *,' after tfpropm,before tfbest'
               call tfwait()
            endif
            begin_ft = nca_prep + 1
            call tfbest()
            if (diag_level.ge.3) then
               call tfl()
               print *,' after tfbest'
               call tfwait()
            endif

*           **** store loop
 9          continue
            if (rlevel_zfpar.eq.1) then
               begin_store = 1
**            elseif (rlevel_zfpar.eq.2) then
            elseif (rlevel_zfpar.ge.2) then
               begin_store = nca_x + 1
            else
               begin_store = nca_prep + 1
            endif
**            print *,'matrip begin_store,nca_x,nca_y,nca_ft=',
**     +           begin_store,nca_x,nca_y,nca_ft
            do 40 ift=begin_store,nca_ft
               if (alive_ft(ift)) then
                  if (quality_ft(ift).lt.qualmin_y_zfpar) go to 40 
#ifdef RT_WHIT
**                 if((rlevel_zfpar.eq.3.or.rlevel_zfpar.eq.4).and.
**     +           whit_zf(last_ft(ift))-whit_zf(first_ft(ift))
**     +                 .lt.whitmin_mcon_zfpar) go to 40

#ifdef ZSEG_CUT
**                 print '("tfmatripn.F : zlast,zfirst=",2(x,f8.3))'
**     +                  ,z_zf(last_ft(ift)),z_zf(first_ft(ift))
**                 if(rlevel_zfpar.le.4.and. 
**     +           abs(z_zf(last_ft(ift)) - z_zf(first_ft(ift))).lt.30.)   
**     +           go to 40 

#endif
*============================================================
#endif
                  call tfstor(ift)
                  if (l_diag) call tfwait()
               endif
 40         continue

 10      continue               ! x clusters
      enddo

**      print *,' tfmatrip done'
 999  end
