//--*-C++-*--
#ifndef RCXKINEMA_H
#define RCXKINEMA_H

// *****************************************************************************
//
// source:    
//
// type:      source code
//
// created:   26 Jul 2000
//	
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// changes:
// 26 Jul 2000 (AG) creation (code from Denis)
//
// *****************************************************************************

#include "arte/arte.hh"
#include "CLHEP/Vector/LorentzVector.h"


class kinema {

 public:
  /// Brehmsstrahlung recovery
  static float findBremsstrahlung(ArtePointer<RTRA> t);

  /// Four-vector creation
  static HepLorentzVector FourVector(ArtePointer<RTRA> t, float m);

  /// Swimming through magnet
  static int swim(const double *source,double *dest,const double zout);

  /// Find line in TOPP table for given lund
  static ArtePointer<TOPP> findTopp(int lund);

};

#endif
