
// *****************************************************************************
//
// source:    rcClassDVTX.C
//
// type:      source code
//
// created:   02 Aug 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcClassDVTX
//
// called by: rcClassify
//
// purpose:   classification of detached vertex events
//
// hints:     return value rc = 0     nothing classified
//
// changes:
// 02 Aug 2000 (AG) creation
//
// *****************************************************************************

// standard includes
#include <iostream.h>

// ARTE includes
#include "farm/farm.hh"

// externals
extern int FADEB;

// prototypes
int rcSelectDVTX();

//
// function code
//
int
rcClassDVTX()
{
  ARTE_mark( "rcClassDVTX 0", 0 );
  
  int rc = rcSelectDVTX();
  
  if( FADEB ) cout << "CLASS: DVTX=0x" << hex << rc << dec << endl;

  ARTE_mark( "rcClassDVTX 1", 0 );
  return rc;
}
