
// *****************************************************************************
//
// source:    rcClassVZERO.C
//
// type:      source code
//
// created:   19 Jul 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcClassVZERO
//
// called by: rcClassify
//
// purpose:   class events with V0 candidate
//
// hints:
//
// changes:
// 19 Jul 2000 (AG) creation
// 21 Jul 2000 (AG) fix bug
// 25 Jul 2000 (AG) added rcSelectVZERO() and rcSelectVZERO2()
// 26 Jul 2000 (AG) stick to one VZERO selection function
// 26 Jul 2000 (AG) use seperate function for VZERO2
//
// *****************************************************************************

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"

// prototypes
int rcSelectVZERO();

//
// function code
//
int
rcClassVZERO()
{
  ARTE_mark( "rcClassVZERO 0", 0 );

  int rc = rcSelectVZERO(); // bit 1:K0s 2:Lambda

  ARTE_mark( "rcClassVZERO 1", 0 );
  return rc;
}
