
// *****************************************************************************
//
// source:    
//
// type:      source code
//
// created:   26 Jul 2000
//	
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// changes:
// 26 Jul 2000 (AG) creation (code from Denis)
// 17 Sep 2000 (DD) attributes for v0-track relations
//
// *****************************************************************************

#include "reco/rcXdecay.h"

//
//
//
decay::decay()
{
  fit              = 3;
  book_tables      = 1;
  rlevel           = 0;
  root_output      = 1;
  calculate_mass   = 1;
  verb             = 0;
}
  
//
//
//
decay::decay(decay &d)
{
  fit            = d.fit;
  book_tables    = d.book_tables;
  rlevel         = d.rlevel;
  root_output    = d.root_output;
  calculate_mass = d.calculate_mass;
  verb           = d.verb;
}

//
//
//
vertexAttrib::vertexAttrib()
{
  rlevel              = 2;
  momentum_flag       = 1;
  remove_old_vertices = 1;
  max_vertex_chi2     = 1e3;
  topp                = 0;
  verb                = 0;
  min_total_mtra_leng = -1e5;
  min_mtra_leng       = -1e5;
  min_dz_from_wire    = -1e5;
  max_drho_from_wire  = 1e5;
  min_mass            = -1e5;
  max_mass            = 1e5;
  check_wire          = 1;
  min_v0_tracks       = 4;
  exclude_v0_tracks   = 0;
  require_v0_tracks   = 0;
  change_track_rtra   = 1;
}

//
//
//
vertexAttrib::vertexAttrib(vertexAttrib &va)
{
  rlevel              = va.rlevel;
  momentum_flag       = va.momentum_flag;
  remove_old_vertices = va.remove_old_vertices;
  max_vertex_chi2     = va.max_vertex_chi2;
  topp                = va.topp;
  verb                = va.verb;
  min_total_mtra_leng = va.min_total_mtra_leng;
  min_mtra_leng       = va.min_mtra_leng;
  min_dz_from_wire    = va.min_dz_from_wire;
  max_drho_from_wire  = va.max_drho_from_wire;
  min_mass            = va.min_mass;
  max_mass            = va.max_mass;
  check_wire          = va.check_wire;
  min_v0_tracks       = va.min_v0_tracks;
  exclude_v0_tracks   = va.exclude_v0_tracks;
  require_v0_tracks   = va.require_v0_tracks;
  change_track_rtra   = va.change_track_rtra;
}
