// -- Authors :    Vik Egorytchev  21/02/99

//************************************************************************
//*                                                                      *
//*   Description: transfers TRD hits from row data tables               *
//*                DTRD to HITB.                                         *
//*                                                                      *
//************************************************************************

#include <iostream.h>
#include "arte/arte.hh"

extern "C" {

void trd2hit(int iCHANAL, int iHIT, float Time)
{
  if( iCHANAL < 80 )
    {
      cout << "trd2hit: unexpected iCHANNEL " << iCHANAL << endl;
      return;
    }

  static int iSTRAW[128];
  static int firstCall = 1;
  static float X4_BL_LEFT = 0, Y4_BL_LEFT = 0, Z4_BL = 0;
  static float X8_BL_LEFT = 0, Y8_BL_LEFT = 0, Z8_BL = 0;
  static float X9_BL_LEFT = 0, Y9_BL_LEFT = 0, Z9_BL = 0;

  static ArtePointer<GEDE> igede1;
  static ArtePointer<GEDE> igede2;
  static ArtePointer<GEDE> igede3;
      

  if( firstCall )
    {
      firstCall = 0;
      int j=0;
      for( ; j< 80  ; j++ ){iSTRAW[j] = 0;};
      for( ; j<=95 ; j++  ){iSTRAW[j] = 112 - j;};
      for( ; j<=111 ; j++ ){iSTRAW[j] = 128 - j;};
      for( ; j<=127 ; j++ ){iSTRAW[j] = 63 - ( 127 - j + 1 );};
      
      for(ArteTable<GESL>::iterator itGesl=ArteTable<GESL>::begin();
	  itGesl != ArteTable<GESL>::end();
	  itGesl++ )
	{
	  if( (*itGesl)->cmp == 6 )
	    {
	      for( ArteRelationIterator<GEDE> itGede = (*itGesl)->gede.begin();
		   itGede != (*itGesl)->gede.end();
		   ++itGede )
		{ 
		  
		  if((*itGede)->sec==4 && (*itGede)->lay==6) {
		    
		    X4_BL_LEFT = (*itGede)->xmin;
		    Y4_BL_LEFT = (*itGede)->ymin;
		    Z4_BL      = (*itGede)->zmin + 0.305;
		    igede1 = *itGede;
		    
		    /*	    cout << " vik: GEDE " 
				  << (*itGede)<<" " << (*itGede)->sec << " " 
				  << (*itGede)->lay << " " 
				  << X4_BL_LEFT << " " 
				  << Y4_BL_LEFT << " "
				  << (*itGede)->ymax << endl;*/
		  };
		  if((*itGede)->sec==8 && (*itGede)->lay==8) {
		    
		    X8_BL_LEFT = (*itGede)->xmin;
		    Y8_BL_LEFT = (*itGede)->ymin;
		    Z8_BL      = (*itGede)->zmin + 0.305;
		    igede2 = *itGede;
		  };
		  if((*itGede)->sec==8 && (*itGede)->lay==9) {
		    
		    X9_BL_LEFT = (*itGede)->xmin;
		    Y9_BL_LEFT = (*itGede)->ymin;
		    Z9_BL      = (*itGede)->zmin + 0.305;
		    igede3 = *itGede;
		  };
		}
	    }
	}
    } // end of initialization

  if( iCHANAL >= 112 ) {

   HITB hitb;

   hitb.x = X4_BL_LEFT + (iSTRAW[iCHANAL]-1)*0.61 + 0.305;
   hitb.y = Y4_BL_LEFT;
   hitb.z = Z4_BL;
   hitb.q = Time;
   hitb.gede = igede1;
   ArtePointer<HITB> hitPtr = ArteTable<HITB>::push_back( hitb );
   if(iHIT==1) {igede1->hit1  = hitPtr;}; 
   igede1->hitl = hitPtr;

   /*   cout << "plane=" << igede1 << " straw = " << iSTRAW[iCHANAL] <<
     " time =" << Time << " " << hitb.x << " " << hitb.y << endl;*/

  };

  if( iCHANAL >= 80 && iCHANAL <=95 ) {

   HITB hitb;

   hitb.x = X8_BL_LEFT + (iSTRAW[iCHANAL]-1)*0.61 + 0.305;
   hitb.y = Y8_BL_LEFT;
   hitb.z = Z8_BL;
   hitb.q = Time;
   hitb.gede = igede2;
   ArtePointer<HITB> hitPtr = ArteTable<HITB>::push_back( hitb );
   if(iHIT==1) {igede2->hit1  = hitPtr;}; 
   igede2->hitl = hitPtr;

   /*   cout << "plane=" << igede2 << " straw = " << iSTRAW[iCHANAL] <<
     " time =" << Time << endl;*/

   };

  if( iCHANAL >= 96 && iCHANAL <=111 ) {

   HITB hitb;

   hitb.x = X9_BL_LEFT + (iSTRAW[iCHANAL]-1)*0.61 + 0.305;
   hitb.y = Y9_BL_LEFT;
   hitb.z = Z9_BL;
   hitb.q = Time;
   hitb.gede = igede3;
   ArtePointer<HITB> hitPtr = ArteTable<HITB>::push_back( hitb );
   if(iHIT==1) {igede3->hit1  = hitPtr;}; 
   igede2->hitl = hitPtr;

   /*  cout << "plane=" << igede3 << " straw = " << iSTRAW[iCHANAL] <<
     " time =" << Time << endl;*/

   };


}   // void trd2hit_()

}
