*CMZ :          20/05/96  12.58.34  by  Unknown
*-- Author :   T.Lohse
c
c------------------------------------------------------------
c
c       subroutine:   VTAVER(iv,x0)
c
c       input:    iv       =  vertex index      Int
c
c       output:   x0(3)    =  approx. vertex    R*8
c
c       action:   approximate vertex from
c                 average of all tracks on iv
c
c------------------------------------------------------------
c
      subroutine VTAVER(iv,x0)

      implicit none

      integer iv
      double precision 
     1  x0(3)

      double precision 
     1  a(2), b(2), ab, aa, xn(2), det, weight
      integer i, j, n, it

#include "vt/vtdat.fi"

      n = ntr(iv)

      x0(1) = 0.
      x0(2) = 0.
      x0(3) = 0.

      if ( n.lt.2 ) return

      a(1)  = 0.
      a(2)  = 0.
      b(1)  = 0.
      b(2)  = 0.
      ab    = 0.
      aa    = 0.
      xn(1) = 0.
      xn(2) = 0.

      do  i = 1, n
        it = ktr(iv,i)
        do  j = 1, 2
          weight  = 1./V(j+2,j+2,it)
          a(j)  = a(j)  + p(j,it)*weight
          b(j)  = b(j)  + p(j+2,it)*weight
          xn(j) = xn(j) + weight
          ab    = ab + p(j,it)*p(j+2,it)*weight**2
          aa    = aa + p(j,it)**2*weight**2
        enddo
      enddo

      det = - aa + a(1)**2/xn(1) + a(2)**2/xn(2)
      if (det.eq.0.) return
      x0(3) = ( ab - a(1)*b(1)/xn(1) - a(2)*b(2)/xn(2) ) / det
      x0(1) = ( b(1) + a(1)*x0(3) ) / xn(1)
      x0(2) = ( b(2) + a(2)*x0(3) ) / xn(2)

      return
      end
