*CMZ :          21/07/97  18.49.06  by  Unknown
*-- Author :   T.Lohse
c
c-------------------------------------------------------------
c
c       function:   VTDTT(it1,it2)                       R*8
c
c       input:    it1      track index 1                 Int
c                 it2      track index 2                 Int
c
c       output:   distance track -- track (chi**2, NDF=1)
c
c-------------------------------------------------------------
c
      double precision 
     1  function VTDTT(it1,it2)

      implicit none
#include "vt/vtdat.fi"

      integer it1,it2

      double precision 
     1  x(3), cov(3,3)

      double precision 
     1  Vmat(4,4)

      integer iv, ifail
      integer i, it, j, l

      data x /0.d0,0.d0,0.d0/
      data cov / 10000.d0,0.d0,0.d0,0.d0,10000.d0,
     1           0.d0,0.d0,0.d0,10000.d0/


      VTDTT = 1.d30

      call VTINIT(x,cov,iv,ifail)
      if ( ifail.lt.0 ) goto 50
      call VTADD(iv,it1,ifail)
      if ( ifail.lt.0 ) goto 100
      call VTADD(iv,it2,ifail)
      if ( ifail.lt.0 ) goto 100

c--->  invert the covariance matrices of the tracks
      do  i = 1, 2
        it = ktr(iv,i)
        if (invflg(it).ne.4) then
          do  j = 1, 4
            do  l = 1, 4
              Vmat(j,l) = V(j,l,it)
            enddo
          enddo
          call DSINV(4,Vmat,4,ifail)
          if (ifail.eq.-1) goto 100
          invflg(it) = 4
          do  j = 1, 4
            do  l = 1, 4
              G(j,l,it) = Vmat(j,l)
            enddo
          enddo
        endif
      enddo

      do  i = 1, 3
        xvs(i,iv) = x(i)
      enddo

      call VTFILT(iv,0,ifail)
      if ( ifail.lt.0 ) goto 100

      VTDTT = chi2(iv,2)

  100 continue

      call VTDEL(iv,ifail)

   50 continue

      return
      end
